lexer grammar ISPL;
@members {
private MCMASEditor editor;
public void setMCMASEditor(MCMASEditor editor) {
	this.editor = editor;
}
public String getErrorHeader(RecognitionException e) {
	return "line "+e.line+":"+e.charPositionInLine+":"+1;
}
public void emitErrorMessage(String str) {
	editor.errorMessage += str + "\n";
}
}
@header {
package org.mcmas.ui.syntax;

import org.mcmas.ui.editors.MCMASEditor;
}

T26 : 'Agent' ;
T27 : 'Environment' ;
T28 : 'end' ;
T29 : 'Obsvars' ;
T30 : ':' ;
T31 : 'Vars' ;
T32 : 'boolean' ;
T33 : ';' ;
T34 : '{' ;
T35 : '}' ;
T36 : '..' ;
T37 : ',' ;
T38 : 'Actions' ;
T39 : '=' ;
T40 : 'RedStates' ;
T41 : 'or' ;
T42 : 'and' ;
T43 : '!' ;
T44 : '(' ;
T45 : ')' ;
T46 : '+' ;
T47 : '-' ;
T48 : '*' ;
T49 : '/' ;
T50 : '<' ;
T51 : '<=' ;
T52 : '>' ;
T53 : '>=' ;
T54 : '<>' ;
T55 : 'true' ;
T56 : 'false' ;
T57 : 'Protocol' ;
T58 : 'Other' ;
T59 : 'Evolution' ;
T60 : 'if' ;
T61 : 'Action' ;
T62 : '.' ;
T63 : 'Evaluation' ;
T64 : 'InitStates' ;
T65 : 'Groups' ;
T66 : 'Fairness' ;
T67 : '->' ;
T68 : 'Formulae' ;
T69 : 'GreenStates' ;
T70 : 'AG' ;
T71 : 'EG' ;
T72 : 'AX' ;
T73 : 'EX' ;
T74 : 'AF' ;
T75 : 'EF' ;
T76 : 'A' ;
T77 : 'U' ;
T78 : 'E' ;
T79 : 'K' ;
T80 : 'GK' ;
T81 : 'GCK' ;
T82 : 'O' ;
T83 : 'KH' ;
T84 : 'DKH' ;
T85 : 'DK' ;
T86 : 'X' ;
T87 : 'F' ;
T88 : 'G' ;

// $ANTLR src "C:\workspace\mcmas\trunk\mcmas+\ui\src\org\mcmas\ui\syntax\ISPL.g" 628
ID	:	('a'..'z'|'A'..'Z')('a'..'z'|'A'..'Z'|'0'..'9'|'_')*
	;
// $ANTLR src "C:\workspace\mcmas\trunk\mcmas+\ui\src\org\mcmas\ui\syntax\ISPL.g" 630
NUM	:	'0'..'9'+ 
	;	
// $ANTLR src "C:\workspace\mcmas\trunk\mcmas+\ui\src\org\mcmas\ui\syntax\ISPL.g" 632
LINE_COMMENT
    : '--' ~('\n'|'\r')* '\r'? '\n' {skip();/* $channel=HIDDEN;*/}
    ;
// $ANTLR src "C:\workspace\mcmas\trunk\mcmas+\ui\src\org\mcmas\ui\syntax\ISPL.g" 635
WS  :   (' '|'\t'|'\r'| '\n')+ {skip();} ;
