package org.mcmas.ui.editors;

import java.awt.Graphics;

/**
 * <p>Title: PET</p>
 *
 * <p>Description: Java UI for PET</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: University of Warwick</p>
 *
 * @author Hongyang Qu
 * @version 1.0
 */
public class CommonOperation {
    // Round float to integer according to fractor
    static public int floor(float x) {
        int y = (int) x;
        if ((x - y) >= 0.5)
            return y + 1;
        else
            return y;
    }

    // xy1 arrow base
    // xy2 arrow point
    // K   blade height
    // N   blade length (hypotenuse)
    // L   blade width (distance from arrow line)

    static void drawArrow(Graphics g, int x1, int y1, int x2, int y2, double K, double N){

        if (K >= N)
            return; // draw nothing if height is greater than length
        double L = Math.sqrt(N * N - K * K);
        int x = x2 - x1;
        int y = y2 - y1;
        double A = Math.sqrt(x * x + y * y);

        int x3 = (int) (((A - K) / A) * x - (L / A) * y);
        int y3 = (int) (((A - K) / A) * y + (L / A) * x);
        int x5 = (int) (((A - K) / A) * x + (L / A) * y);
        int y5 = (int) (((A - K) / A) * y - (L / A) * x);

        int x4 = x1 + x3;
        int y4 = y1 + y3;
        int x6 = x1 + x5;
        int y6 = y1 + y5;

        g.drawLine(x1, y1, x2, y2); // line
        g.drawLine(x2, y2, x4, y4); // blade left
        g.drawLine(x2, y2, x6, y6); // blade right
    }
}
