package org.mcmas.ui.editors;

import java.io.BufferedReader;
import java.io.IOException;
import java.lang.InterruptedException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.operation.IRunnableWithProgress;

public class ExecuteMCMAS implements IRunnableWithProgress  {
	private MultiPageEditor meditor;
	private String[] path;
	private String cygwinPath;
	private int osType;

	public ExecuteMCMAS(MultiPageEditor meditor, String[] path, int osType, String cygwinPath) {
		this.meditor = meditor;
		this.path = path;
		this.osType = osType;
		this.cygwinPath = cygwinPath;
	}
	
	public void run(IProgressMonitor monitor) throws InvocationTargetException,
			InterruptedException {
		// TODO Auto-generated method stub
		try{
			Runtime rt = Runtime.getRuntime();
		    Process proc;
		    
		    if(osType > 0) {
		    	proc = rt.exec(path);
		    }
		    else {
		    	proc = rt.exec(path, new String[]{cygwinPath});
		    }
		    monitor.beginTask("MCMAS is running...", IProgressMonitor.UNKNOWN);
		    //StreamGobbler outputGobbler = new  StreamGobbler(proc.getInputStream(), "OUTPUT");
			//meditor.output = outputGobbler.getOutput();
		    try {
				InputStreamReader isr = new InputStreamReader(proc.getInputStream()); 
				InputStreamReader isr1 = new InputStreamReader(proc.getErrorStream());
				BufferedReader br = new BufferedReader(isr);
				BufferedReader br1 = new BufferedReader(isr1);
				String line = null;
				while(!br.ready()) {
					if(monitor.isCanceled()) {
						proc.destroy();
						throw new InterruptedException();
					}
					if(br1.ready())
						while(br1.ready()) 
							line = br1.readLine();
					else
						Thread.sleep(200);
				}
				
				while ((line = br.readLine()) != null) {
					monitor.subTask(line);
					if(line.startsWith("Verifying"))
						break;
					
					while(!br.ready()) {
						if(monitor.isCanceled()) {
							proc.destroy();
							throw new InterruptedException();
						}
						Thread.sleep(200);
					}
				}
				
				while(!br.ready()) {
					if(monitor.isCanceled()) {
						proc.destroy();
						throw new InterruptedException();
					}
					Thread.sleep(200);
				}
				
				while ((line = br.readLine()) != null) {
					meditor.output += line + "\n";
					if(monitor.isCanceled()) {
						proc.destroy();
						throw new InterruptedException();
					}
				}
			} catch (IOException ioe) {
				ioe.printStackTrace();
			}
			// wait(20000);
			// meditor.output = "FALSE\nTRUE\nFALSE\n";
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
}
