package org.mcmas.ui.editors;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Panel;
import java.awt.Polygon;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.regex.Pattern;

import javax.swing.JPanel;

import org.eclipse.jface.text.Position;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Display;

//import javax.swing.JPanel;

public class FlowCanvas extends JPanel implements MouseListener, MouseMotionListener {

    File flowChart;
    Hashtable<Integer, Position> positions;
    StyledText info;
    File sourceText;
    File sourceArray;
    int preferredx;
    int preferredy;
    int shiftx = 10;
    int shifty = 10;
    int minshifty = 2;
    int Width = 0;
    int Height = 0;
    int DotInch = 36;
    Panel parentPanel;
    Dimension canvasSize;
    Object[] currentNode = null;
    Object[] pressedNode = null;
    int currentIndex = -1;
    int pressedIndex = -1;
    Frame parentFrame;
    //String programName;
    int[][] succArray;
    boolean isChangeBounds = false;
    String lowerBound1, upperBound1, lowerBound2, upperBound2;
    static final long serialVersionUID = 0;

    ArrayList<ArrayList<String>> alLine = new ArrayList<ArrayList<String>>();
    ArrayList<Integer> alLineDotted = new ArrayList<Integer>();
    ArrayList<Object[]> alNode = new ArrayList<Object[]>();
    ArrayList<ArrayList<String>> alLabel = new ArrayList<ArrayList<String>>();
    int[][] sourceCoords = null;

    public FlowCanvas(Frame p) {
        parentFrame = p;
        addMouseMotionListener(this);
        addMouseListener(this);
    }

    public void setFile(File fname) {
        //programName = fname;
        flowChart = fname;
    }
    
    public void setCounterExampleInfo(StyledText info, Hashtable<Integer, Position> positions) {
    	this.info = info;
    	this.positions = positions;
    }

    public void setPreferredWindowSize(Dimension d) {
        preferredx = d.width;
        preferredy = d.height;
    }

    public Dimension getCanvasSize() {
        return canvasSize;
    }

    //Get successors of each node
    public void setArray(int[][] sa) {
        succArray = sa;
    }

    //Analyze file and store components in arraylists
    public boolean readDotFile(String dotPath, int osType){
        String temps;
        Pattern p = Pattern.compile(" ");
        Pattern p1 = Pattern.compile(",");

        ArrayList<String> al;
        al = ExecDot.executeDot(dotPath, flowChart.getAbsolutePath(), osType);

        if (al == null)
            return false;

        for (int alindex = 0; alindex < al.size(); alindex++) {
            temps = (String) al.get(alindex);
            //System.out.println("\""+temps+"\"");
            if (temps.indexOf("digraph") >= 0 || temps.indexOf("node") >= 0 ||
                temps.indexOf("}") >= 0)
                continue;
            else if (temps.indexOf("graph") >= 0 && temps.indexOf("bb") >= 0) {
                int i = temps.indexOf("\"");
                String[] sp = p1.split(temps.substring(i + 1, temps.length() - 3));
                Width = Integer.parseInt(sp[2]);
                Height = Integer.parseInt(sp[3]);
                //setPanelSize(new Dimension(Width+shiftx*2, Height+shifty*2));
                //setPreferredSize(new Dimension(Width+shiftx*2, Height+shifty*2));
                canvasSize = new Dimension(Width + shiftx * 2, Height + shifty * 2);
                shiftx = Width < preferredx ?
                         (int) ((preferredx - shiftx) / 2) + shiftx : shiftx;
                shifty = Height < preferredy ?
                         (int) ((preferredy - shifty) / 2) + shifty : shifty;
            } else if (temps.indexOf("->") >= 0) {
                //Dealing with position
                int posi = temps.indexOf("pos=\"") + 5;
                while(posi<5) {
                	alindex++;
                	temps = temps.substring(0, temps.length()-1);
                	temps += (String) al.get(alindex);
                	posi = temps.indexOf("pos=\"") + 5;
                }
                int posj = temps.indexOf("\"", posi);
                char direction = temps.charAt(posi);

                String[] sp = p.split(temps.substring(posi + 2, posj));
                int[] x = new int[sp.length];
                int[] y = new int[sp.length];

                String dir = "";
                if (direction == 'e') {
                    dir = "last";
                    for (int i = 1; i < sp.length; i++) {
                        String[] sp1 = p1.split(sp[i]);
                        x[i - 1] = Integer.parseInt(sp1[0]) + shiftx;
                        y[i - 1] = Height - Integer.parseInt(sp1[1]) + shifty;
                    }
                    String[] sp1 = p1.split(sp[0]);
                    x[x.length - 1] = Integer.parseInt(sp1[0]) + shiftx;
                    y[y.length - 1] = Height - Integer.parseInt(sp1[1]) + shifty;
                } else {
                    dir = "first";
                    for (int i = 0; i < sp.length; i++) {
                        String[] sp1 = p1.split(sp[i]);
                        x[i] = Integer.parseInt(sp1[0]) + shiftx;
                        y[i] = Height - Integer.parseInt(sp1[1]) + shifty;
                    }
                }
                ArrayList<String> alline = new ArrayList<String>(x.length * 2 + 1);
                alline.add(dir);
                for (int i = 0; i < x.length; i++) {
                    alline.add(Integer.toString(x[i]));
                    alline.add(Integer.toString(y[i]));
                }
                
                Integer attribute = (temps.indexOf("dotted") >= 0) ? new Integer(1) : new Integer(0);
                alLineDotted.add(attribute);
                alLine.add(alline);
                //Dealing with label
                posi = temps.indexOf("label=");
                if (posi > 0) {
                    posi = posi + 6;
                    posj = temps.indexOf(",", posi);
                    posi = temps.charAt(posi) == '\"' ? posi + 1 : posi;
                    posj = temps.charAt(posj - 1) == '\"' ? posj - 1 : posj;
                    String label = temps.substring(posi, posj);
                    label = label.replace(';', ',');
                    posi = temps.indexOf("lp=\"") + 4;
                    posj = temps.indexOf("\"", posi);
                    String[] sp2 = p1.split(temps.substring(posi, posj));
                    int labelx = Integer.parseInt(sp2[0]) + shiftx;
                    int labely = Height - Integer.parseInt(sp2[1]) + shifty;
                    ArrayList<String> allabel = new ArrayList<String>(3);
                    allabel.add(label);
                    allabel.add(Integer.toString(labelx));
                    allabel.add(Integer.toString(labely));
                    alLabel.add(allabel);
                }
            } else { //Dealing with nodes
                //Dealing with label of node
                int posi = temps.indexOf("label=") + 6;
                int posj = temps.indexOf(",", posi);
                posi = temps.charAt(posi) == '\"' ? posi + 1 : posi;
                posj = temps.charAt(posj - 1) == '\"' ? posj - 1 : posj;
                String label = temps.substring(posi, posj);
                ArrayList<String> allabel = new ArrayList<String>(3);
                allabel.add(label);

                //Get node number from label
                //posj = temps.indexOf(":", posi);
                //int nodeNum = Integer.parseInt(temps.substring(posi, posj));
                int nodeNum = Integer.parseInt(label);
                
                //Dealing with position of node
                posi = temps.indexOf("pos=\"") + 5;
                posj = temps.indexOf("\"", posi);
                String[] pos = p1.split(temps.substring(posi, posj));
                int x = Integer.parseInt(pos[0]) + shiftx;
                int y = Height - Integer.parseInt(pos[1]) + shifty;
                allabel.add(Integer.toString(x));
                allabel.add(Integer.toString(y));
                alLabel.add(allabel);

                //Dealing with width of node
                posi = temps.indexOf("width=\"") + 7;
                posj = temps.indexOf("\"", posi);
                float width = Float.parseFloat(temps.substring(posi, posj));

                //Dealing with height of node
                posi = temps.indexOf("height=\"") + 8;
                posj = temps.indexOf("\"", posi);
                float height = Float.parseFloat(temps.substring(posi, posj));

                //Dealing with shape of node
                posi = temps.indexOf("shape=") + 6;
                posj = temps.indexOf(",", posi);
                String shape = temps.substring(posi, posj);

                //Generate the actual shape
                //int cx = (int)(DotInch*width);
                //int cy = (int)(DotInch*height);
                int cx = CommonOperation.floor(DotInch * width);
                int cy = CommonOperation.floor(DotInch * height);
                Object[] alnode = new Object[3];
                alnode[2] = new Integer(nodeNum);
                if (shape.equals("diamond")) {
                    int[] coordsx = new int[4];
                    int[] coordsy = new int[4];
                    coordsx[0] = x - cx;
                    coordsy[0] = y;
                    coordsx[1] = x;
                    coordsy[1] = y - cy;
                    coordsx[2] = x + cx;
                    coordsy[2] = y;
                    coordsx[3] = x;
                    coordsy[3] = y + cy;
                    alnode[0] = shape;
                    alnode[1] = new Polygon(coordsx, coordsy, 4);
                    alNode.add(alnode);
                } else if (shape.equals("hexagon")) {
                    int[] coordsx = new int[6];
                    int[] coordsy = new int[6];
                    int cx2 = CommonOperation.floor(DotInch * width / 2);
                    //coordsx[0] = x - cx / 2;
                    coordsx[0] = x - cx2;
                    coordsy[0] = y - cy;
                    coordsx[1] = x - cx;
                    coordsy[1] = y;
                    //coordsx[2] = x - cx / 2;
                    coordsx[2] = x - cx2;
                    coordsy[2] = y + cy;
                    //coordsx[3] = x + cx / 2;
                    coordsx[3] = x + cx2;
                    coordsy[3] = y + cy;
                    coordsx[4] = x + cx;
                    coordsy[4] = y;
                    //coordsx[5] = x + cx / 2;
                    coordsx[5] = x + cx2;
                    coordsy[5] = y - cy;
                    alnode[0] = shape;
                    alnode[1] = new Polygon(coordsx, coordsy, 6);
                    alNode.add(alnode);
                } else {
                    int x1 = x - cx;
                    int y1 = y - cy;
                    int x2 = x + cx;
                    int y2 = y + cy;
                    alnode[0] = shape;
                    if (shape.equals("box"))
                        alnode[1] = new Rectangle2D.Double(x1, y1, x2 - x1, y2 - y1);
                    else
                        alnode[1] = new Ellipse2D.Double(x1, y1, x2 - x1, y2 - y1);
                    alNode.add(alnode);
                }

                alLabel.add(allabel);
            }
        }

        return true;
    }

    public void paint(Graphics g) {
        //Ellipse2D.Double circle;
        //Rectangle2D.Double square;
        //Polygon polygon;
        Graphics2D g2d = (Graphics2D)g;
        super.paint(g);
        //g2d.fill(circle);
        //g2d.draw(square);
        int x1, y1, x2, y2;
        Color oldColor = g.getColor();
        for(int i=0;i<alLine.size();i++){
            ArrayList<String> alline = alLine.get(i);
            int attribute = alLineDotted.get(i).intValue();
            if(attribute == 1)
            	g.setColor(Color.RED);
            int j;
            for(j=0;j<(int)(alline.size()/2)-2;j++){
                x1 = Integer.parseInt((String)(alline.get(j*2+1)));
                y1 = Integer.parseInt((String)(alline.get(j*2+2)));
                x2 = Integer.parseInt((String)(alline.get(j*2+3)));
                y2 = Integer.parseInt((String)(alline.get(j*2+4)));
                g.drawLine(x1,y1,x2,y2);
            }
            x1 = Integer.parseInt((String) (alline.get(j * 2 + 1)));
            y1 = Integer.parseInt((String) (alline.get(j * 2 + 2)));
            x2 = Integer.parseInt((String) (alline.get(j * 2 + 3)));
            y2 = Integer.parseInt((String) (alline.get(j * 2 + 4)));
            CommonOperation.drawArrow(g2d, x1, y1, x2, y2, 9, 10);
            if(attribute == 1)
            	g.setColor(oldColor);
        }

        for(int i=0;i<alNode.size();i++){
            Object[] alnode = (Object[])(alNode.get(i));
            if (((String)alnode[0]).equals("box")) {
                if(currentIndex==i)
                    g2d.setColor(Color.yellow);
                else if(pressedIndex==i)
                    g2d.setColor(Color.red);
                else
                    g2d.setColor(Color.green);
                g2d.fill((Rectangle2D.Double)(alnode[1]));
                g2d.setColor(Color.black);
                g2d.draw((Rectangle2D.Double)(alnode[1]));
             } else if (((String)alnode[0]).equals("ellipse")) {
                if(currentIndex==i)
                    g2d.setColor(Color.yellow);
                else if(pressedIndex==i)
                    g2d.setColor(Color.red);
                else
                    g2d.setColor(Color.orange);
                g2d.fill((Ellipse2D.Double)(alnode[1]));
                g2d.setColor(Color.black);
                g2d.draw((Ellipse2D.Double)(alnode[1]));
            }
            else {
                if(currentIndex==i)
                    g2d.setColor(Color.yellow);
                else if(pressedIndex==i)
                    g2d.setColor(Color.red);
                else if (((String)alnode[0]).equals("diamond"))
                    g2d.setColor(Color.magenta);
                else
                    g2d.setColor(Color.cyan);

                g2d.fill((Polygon)(alnode[1]));
                g2d.setColor(Color.black);
                g2d.draw((Polygon)(alnode[1]));
            }
        }

        FontMetrics fm = g.getFontMetrics();
        g2d.setColor(Color.black);
        for(int i=0;i<alLabel.size();i++){
            ArrayList<String> allabel = (ArrayList<String>)alLabel.get(i);
            String label = (String)(allabel.get(0));
            x1 = Integer.parseInt((String)(allabel.get(1)))-
                 (int)(fm.stringWidth(label)/2);
            y1 = Integer.parseInt((String)(allabel.get(2)))+minshifty+1;

            g.drawString(label, x1, y1);
        }

    }

    public boolean checkSucc(int cnodeNum, int pi) {
        if (pi < 0)
            return true;
        int k = ((Integer) pressedNode[2]).intValue();
        for (int i = 0; i < 2; i++) {
            if (succArray[k][i] == cnodeNum)
                return true;
        }
        return false;
    }

    public void removePressed() {
        pressedNode = null;
        pressedIndex = -1;
        repaint();
    }

    public int getIndexFromNum(int nodenum) {
        for(int i=0; i<alNode.size(); i++){
            Object[] alnode = (Object[])alNode.get(i);
            if(((Integer)alnode[2]).intValue()==nodenum)
                return i;
        }
        return -1;
    }

    public void setPressed(int nodeNum) {
        int k = getIndexFromNum(nodeNum);
        pressedNode = (Object[])alNode.get(k);
        pressedIndex = k;
        repaint();
    }

    public void setChangeBounds(boolean b) {
        isChangeBounds = b;
    }

    public void setTimeBounds(String lb1, String ub1, String lb2, String ub2) {
        lowerBound1 = lb1;
        upperBound1 = ub1;
        lowerBound2 = lb2;
        upperBound2 = ub2;
    }

    // Handles the event of the user pressing down the mouse button.
    public void mousePressed(MouseEvent e){
        if (e.getButton() == MouseEvent.BUTTON1) {

        }
        else if(e.getButton() == MouseEvent.BUTTON3) {
        	
        }

    }

    // Handles the event of a user dragging the mouse while holding
    // down the mouse button.
    public void mouseDragged(MouseEvent e){}

    // Handles the event of a user releasing the mouse button.
    public void mouseReleased(MouseEvent e){}

     // This method is required by MouseListener.
     public void mouseMoved(MouseEvent e){
         boolean isInCurrentNode = false;
         if(currentNode != null){
            if (((String)currentNode[0]).equals("box")) {
                isInCurrentNode = ((Rectangle2D.Double)(currentNode[1])).contains(e.getX(),e.getY());
            } else if (((String)currentNode[0]).equals("ellipse")) {
                isInCurrentNode = ((Ellipse2D.Double)(currentNode[1])).contains(e.getX(),e.getY());
            }
            else {
                isInCurrentNode = ((Polygon)(currentNode[1])).contains(e.getX(),e.getY());
            }
            if(!isInCurrentNode){
                currentNode = null;
                currentIndex = -1;
                repaint();
                Display.getDefault().syncExec(new Runnable() {
        			public void run(){
        				info.setSelectionRange(info.getCaretOffset(),0);
        			}
        		});
            }
        }
        else {
            for(int i=0; i<alNode.size(); i++) {
                Object[] alnode = (Object[])alNode.get(i);
                if (((String)alnode[0]).equals("box")) {
                    if(((Rectangle2D.Double) (alnode[1])).contains(e.getX(),e.getY())) {
                        currentNode = alnode;
                        currentIndex = i;
                        break;
                    }
                } else if (((String)alnode[0]).equals("ellipse")) {
                    if(((Ellipse2D.Double) (alnode[1])).contains(e.getX(),e.getY())) {
                        currentNode = alnode;
                        currentIndex = i;
                        break;
                    }
                } else {
                    if(((Polygon) (alnode[1])).contains(e.getX(),e.getY())) {
                        currentNode = alnode;
                        currentIndex = i;
                        break;
                    }
                }
            }
            if (currentNode != null) {
                //System.out.println("Current Node is " +
                //                   Integer.toString(currentIndex));
                repaint();
                final Position p = positions.get((Integer)currentNode[2]);
                Display.getDefault().syncExec(new Runnable() {
        			public void run(){
        				info.setSelection(p.offset, p.offset+p.length);
        			}
        		});
            }
        }
     }

     public void cancelHighlight() {
         currentNode = null;
         currentIndex = -1;
         repaint();
     }

     public void setHighlight(int nodeNum) {
         for(int i=0; i<alNode.size(); i++) {
             Object[] alnode = (Object[])alNode.get(i);
             int k = ((Integer)(alnode[2])).intValue();
             if(k==nodeNum){
                 currentNode = alnode;
                 currentIndex = i;
                 repaint();
             }
         }
     }

     // These methods are required by MouseMotionListener.
     public void mouseClicked(MouseEvent e){}
     public void mouseExited(MouseEvent e){}
     public void mouseEntered(MouseEvent e){}

}
