package org.mcmas.ui.editors;


import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.rules.*;

/**
 * This scanner recognises a variable.
 */
public class IsplItemScanner extends RuleBasedPartitionScanner {

	public final static String ISPL_Item= "__ispl_item"; 
	
	public final static String[] ISPL_PARTITION_TYPES= new String[] { ISPL_Item };


	/**
	 * Creates the partitioner and sets up the appropriate rules.
	 */
	public IsplItemScanner() {
		super();

		IToken IsplItem= new Token(ISPL_Item);

		List<IPredicateRule> rules= new ArrayList<IPredicateRule>();

		// Add rule for single line comments.
		rules.add(new EndOfLineRule("--", Token.UNDEFINED)); //$NON-NLS-1$


		// Add rules for multi-line obsvars, vars, actions, redstates, protocol and evoliution.
		rules.add(new MultiLineRule("a", ";", IsplItem, (char) 0, true)); 

		IPredicateRule[] result= new IPredicateRule[rules.size()];
		rules.toArray(result);
		setPredicateRules(result);
	}
}
