package org.mcmas.ui.editors;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.reconciler.DirtyRegion;
import org.eclipse.jface.text.reconciler.IReconcilingStrategy;
import org.eclipse.swt.widgets.Display;

public class IsplReconcilingStrategy implements IReconcilingStrategy {
	private MCMASEditor fEditor;

	public IsplReconcilingStrategy(MCMASEditor anEditor) {
		fEditor = anEditor;
	}

	public void setDocument(IDocument aDocument) {
		parse();
	}

	public void reconcile(DirtyRegion aDirtyRegion, IRegion aRegion) {
		parse();
	}

	public void reconcile(IRegion aPartition) {
		parse();
	}

	private void parse() {
		fEditor.checkSyntax();
		// Update outline view 
		Display.getDefault().syncExec(new Runnable() {
			public void run(){
				fEditor.updateOutlinePage();
				fEditor.updateFoldingStructure();
			}
		});
	}
	
}
