package org.mcmas.ui.editors;


import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.rules.*;

/**
 * This scanner recognises a variable.
 */
public class IsplStateScanner extends RuleBasedPartitionScanner {

	public final static String ISPL_VARIABLE= "__ispl_variable"; 
	
	public final static String[] ISPL_PARTITION_TYPES= new String[] { ISPL_VARIABLE };


	/**
	 * Creates the partitioner and sets up the appropriate rules.
	 */
	public IsplStateScanner() {
		super();

		IToken IsplVariable= new Token(ISPL_VARIABLE);

		List<IPredicateRule> rules= new ArrayList<IPredicateRule>();

		// Add rule for single line comments.
		rules.add(new EndOfLineRule("--", Token.UNDEFINED)); //$NON-NLS-1$


		// Add rules for multi-line obsvars, vars, actions, redstates, protocol and evoliution.
		rules.add(new MultiLineRule(":", ";", IsplVariable, (char) 0, true)); 

		IPredicateRule[] result= new IPredicateRule[rules.size()];
		rules.toArray(result);
		setPredicateRules(result);
	}
}
