package org.mcmas.ui.editors;


import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.text.rules.*;

/**
 * This scanner recognizes a single word.
 */
public class IsplWordScanner extends RuleBasedScanner {

	public final static String ISPL_WORD= "__ispl_word"; 
	public final static String ISPL_AGENT= "__ispl_agent"; 
	public final static String ISPL_EVALUATION= "__ispl_evaluation";
	public final static String ISPL_INITSTATES= "__ispl_initstates"; 
	public final static String ISPL_GROUPS= "__ispl_groups";
	public final static String ISPL_FAIRNESS= "__ispl_fairness"; 
	public final static String ISPL_FORMULAE= "__ispl_formulae";
	public final static String ISPL_OBSVARS= "__ispl_obsvars"; 
	public final static String ISPL_VARS= "__ispl_vars";
	public final static String ISPL_REDSTATES= "__ispl_RedStates"; 
	public final static String ISPL_ACTIONS= "__ispl_actions";
	public final static String ISPL_PROTOCOL= "__ispl_protocol"; 
	public final static String ISPL_EVOLUTION= "__ispl_evolution";
	public final static String ISPL_ACTION= "__ispl_action"; 
	public final static String ISPL_END= "__ispl_end";
	public final static String ISPL_OTHER= "__ispl_other"; 
	public final static String ISPL_IF= "__ispl_if";
	public final static String ISPL_BOOLEAN= "__ispl_boolean"; 
	public final static String ISPL_TRUE= "__ispl_true";
	public final static String ISPL_FALSE= "__ispl_false"; 
	public final static String ISPL_AND= "__ispl_and";
	public final static String ISPL_OR= "__ispl_or"; 
	public final static String ISPL_AG= "__ispl_ag";
	public final static String ISPL_EG= "__ispl_eg"; 
	public final static String ISPL_AX= "__ispl_ax";
	public final static String ISPL_EX= "__ispl_ex"; 
	public final static String ISPL_X= "__ispl_x";
	public final static String ISPL_F= "__ispl_f"; 
	public final static String ISPL_G= "__ispl_g";
	public final static String ISPL_AF= "__ispl_af"; 
	public final static String ISPL_EF= "__ispl_ef";
	public final static String ISPL_A= "__ispl_a"; 
	public final static String ISPL_E= "__ispl_e";
	public final static String ISPL_U= "__ispl_u"; 
	public final static String ISPL_K= "__ispl_k";
	public final static String ISPL_GK= "__ispl_gk"; 
	public final static String ISPL_GCK= "__ispl_if";
	public final static String ISPL_O= "__ispl_o"; 
	public final static String ISPL_KH= "__ispl_kh";
	public final static String ISPL_DKH= "__ispl_dkh"; 
	public final static String ISPL_DK= "__ispl_dk";
	public final static String ISPL_GREENSTATES= "__ispl_GreenStates";


	public final static String[] ISPL_PARTITION_TYPES= new String[] { ISPL_WORD,
		ISPL_AGENT, ISPL_EVALUATION, ISPL_INITSTATES, ISPL_GROUPS, ISPL_FAIRNESS, ISPL_FORMULAE,
		ISPL_OBSVARS, ISPL_VARS, ISPL_REDSTATES, ISPL_ACTIONS, ISPL_PROTOCOL, ISPL_EVOLUTION,
		ISPL_ACTION, ISPL_END, ISPL_OTHER, ISPL_IF, ISPL_BOOLEAN, ISPL_TRUE, ISPL_FALSE,
		ISPL_AND, ISPL_OR, ISPL_AG, ISPL_EG, ISPL_AX, ISPL_EX, ISPL_X, ISPL_F, ISPL_G, 
		ISPL_AF, ISPL_EF, ISPL_A, ISPL_E, ISPL_U, ISPL_K, ISPL_GK, ISPL_GCK, ISPL_O, 
		ISPL_KH, ISPL_DKH, ISPL_DK, ISPL_GREENSTATES};


	/**
	 * Creates the partitioner and sets up the appropriate rules.
	 */
	public IsplWordScanner() {
		super();

		IToken IsplWord= new Token(ISPL_WORD);
		IToken IsplAgent= new Token(ISPL_AGENT);
		IToken IsplEvaluation= new Token(ISPL_EVALUATION);
		IToken IsplInitstates= new Token(ISPL_INITSTATES);
		IToken IsplGroups= new Token(ISPL_GROUPS);
		IToken IsplFairness= new Token(ISPL_FAIRNESS);
		IToken IsplFormulae= new Token(ISPL_FORMULAE);
		IToken IsplObsvars= new Token(ISPL_OBSVARS);
		IToken IsplVars= new Token(ISPL_VARS);
		IToken IsplRedstates= new Token(ISPL_REDSTATES);
		IToken IsplActions= new Token(ISPL_ACTIONS);
		IToken IsplProtocol= new Token(ISPL_PROTOCOL);
		IToken IsplEvolution= new Token(ISPL_EVOLUTION);
		IToken IsplAction= new Token(ISPL_ACTION); 
		IToken IsplEnd= new Token( ISPL_END); 
		IToken IsplOther= new Token( ISPL_OTHER); 
		IToken IsplIf= new Token( ISPL_IF); 
		IToken IsplBoolean= new Token( ISPL_BOOLEAN); 
		IToken IsplTrue= new Token( ISPL_TRUE); 
		IToken IsplFalse= new Token( ISPL_FALSE); 
		IToken IsplAnd= new Token(	ISPL_AND); 
		IToken IsplOr= new Token( ISPL_OR); 
		IToken IsplAg= new Token( ISPL_AG); 
		IToken IsplEg= new Token( ISPL_EG); 
		IToken IsplAx= new Token( ISPL_AX); 
		IToken IsplEx= new Token( ISPL_EX); 
		IToken IsplX= new Token( ISPL_X); 
		IToken IsplF= new Token( ISPL_F); 
		IToken IsplG= new Token( ISPL_G); 
		IToken IsplAf= new Token( ISPL_AF); 
		IToken IsplEf= new Token( ISPL_EF); 
		IToken IsplA= new Token( ISPL_A); 
		IToken IsplE= new Token( ISPL_E); 
		IToken IsplU= new Token( ISPL_U); 
		IToken IsplK= new Token( ISPL_K); 
		IToken IsplGk= new Token( ISPL_GK); 
		IToken IsplGck= new Token( ISPL_GCK); 
		IToken IsplO= new Token( ISPL_O); 
		IToken IsplKh= new Token( ISPL_KH); 
		IToken IsplDkh= new Token( ISPL_DKH); 
		IToken IsplDk= new Token( ISPL_DK);
		IToken IsplGreenStates= new Token( ISPL_GREENSTATES);
		List<IRule> rules= new ArrayList<IRule>();

		// Add rule for single line comments.
		rules.add(new EndOfLineRule("--", Token.UNDEFINED)); //$NON-NLS-1$

		// Add generic whitespace rule.
		rules.add(new WhitespaceRule(new IsplWhitespaceDetector()));

		// Add word rule for keywords, types, and constants.
		WordRule wordRule= new WordRule(new IsplWordDetector(), IsplWord);
		wordRule.addWord("Agent", IsplAgent);
		wordRule.addWord("Evaluation", IsplEvaluation);
		wordRule.addWord("InitStates", IsplInitstates);
		wordRule.addWord("Groups", IsplGroups);
		wordRule.addWord("Fairness", IsplFairness);
		wordRule.addWord("Formulae", IsplFormulae);
		wordRule.addWord("Obsvars", IsplObsvars);
		wordRule.addWord("Vars", IsplVars);
		wordRule.addWord("RedStates", IsplRedstates);
		wordRule.addWord("Actions", IsplActions);
		wordRule.addWord("Protocol", IsplProtocol);
		wordRule.addWord("Evolution", IsplEvolution);
		wordRule.addWord("Action", IsplAction);
		wordRule.addWord("end", IsplEnd);
		wordRule.addWord("Other", IsplOther);
		wordRule.addWord("if", IsplIf);
		wordRule.addWord("boolean", IsplBoolean);
		wordRule.addWord("true", IsplTrue);
		wordRule.addWord("false", IsplFalse);
		wordRule.addWord("and", IsplAnd);
		wordRule.addWord("or", IsplOr);
		wordRule.addWord("AG", IsplAg);
		wordRule.addWord("EG", IsplEg);
		wordRule.addWord("AX", IsplAx);
		wordRule.addWord("Ex", IsplEx);
		wordRule.addWord("X", IsplX);
		wordRule.addWord("F", IsplF);
		wordRule.addWord("G", IsplG);
		wordRule.addWord("AF", IsplAf);
		wordRule.addWord("EF", IsplEf);
		wordRule.addWord("A", IsplA);
		wordRule.addWord("E", IsplE);
		wordRule.addWord("U", IsplU);
		wordRule.addWord("K", IsplK);
		wordRule.addWord("GK", IsplGk);
		wordRule.addWord("GCK", IsplGck);
		wordRule.addWord("O", IsplO);
		wordRule.addWord("KH", IsplKh);
		wordRule.addWord("DKH", IsplDkh);
		wordRule.addWord("DK", IsplDk);
		wordRule.addWord("GreenStates", IsplGreenStates);

		rules.add(wordRule);

		IRule[] result= new IRule[rules.size()];
		rules.toArray(result);
		setRules(result);
	}
	
	public static String getKeyWordID(String name) {
		if(name.compareTo("Agent") == 0) 
			return ISPL_AGENT;
		if(name.compareTo("Evaluation") == 0)
			return ISPL_EVALUATION;
		if(name.compareTo("InitStates") == 0)
			return ISPL_INITSTATES;
		if(name.compareTo("Groups") == 0)
			return ISPL_GROUPS;
		if(name.compareTo("Fairness") == 0)
			return ISPL_FAIRNESS;
		if(name.compareTo("Formulae") == 0)
			return ISPL_FORMULAE;
		if(name.compareTo("Obsvars") == 0)
			return ISPL_OBSVARS;
		if(name.compareTo("Vars") == 0)
			return ISPL_VARS;
		if(name.compareTo("RedStates") == 0)
			return ISPL_REDSTATES;
		if(name.compareTo("Actions") == 0) 
			return ISPL_ACTIONS;
		if(name.compareTo("Protocol") == 0) 
			return ISPL_PROTOCOL;
		if(name.compareTo("Evolution") == 0) 
			return ISPL_EVOLUTION;
		if(name.compareTo("Action") == 0) 
			return ISPL_ACTION;
		if(name.compareTo("End") == 0) 
			return ISPL_END;
		if(name.compareTo("Other") == 0) 
			return ISPL_OTHER;
		if(name.compareTo("if") == 0) 
			return ISPL_IF;
		if(name.compareTo("boolean") == 0) 
			return ISPL_BOOLEAN;
		if(name.compareTo("true") == 0) 
			return ISPL_TRUE;
		if(name.compareTo("false") == 0) 
			return ISPL_FALSE;
		if(name.compareTo("and") == 0) 
			return ISPL_AND;
		if(name.compareTo("or") == 0) 
			return ISPL_OR;
		if(name.compareTo("AG") == 0) 
			return ISPL_AG;
		if(name.compareTo("EG") == 0) 
			return ISPL_EG;
		if(name.compareTo("AX") == 0) 
			return ISPL_AX;
		if(name.compareTo("Ex") == 0) 
			return ISPL_EX;
		if(name.compareTo("X") == 0) 
			return ISPL_X;
		if(name.compareTo("F") == 0) 
			return ISPL_F;
		if(name.compareTo("G") == 0) 
			return ISPL_G;
		if(name.compareTo("AF") == 0) 
			return ISPL_AF;
		if(name.compareTo("EF") == 0) 
			return ISPL_EF;
		if(name.compareTo("A") == 0) 
			return ISPL_A;
		if(name.compareTo("E") == 0) 
			return ISPL_E;
		if(name.compareTo("U") == 0) 
			return ISPL_U;
		if(name.compareTo("K") == 0) 
			return ISPL_K;
		if(name.compareTo("GK") == 0) 
			return ISPL_GK;
		if(name.compareTo("GCK") == 0) 
			return ISPL_GCK;
		if(name.compareTo("O") == 0) 
			return ISPL_O;
		if(name.compareTo("KH") == 0) 
			return ISPL_KH;
		if(name.compareTo("DKH") == 0) 
			return ISPL_DKH;
		if(name.compareTo("DK") == 0) 
			return ISPL_DK;
		if(name.compareTo("GreenStates") == 0)
			return ISPL_GREENSTATES;
		return ISPL_WORD;
	}
}
