package org.mcmas.ui.editors;

import java.util.ArrayList;

import org.eclipse.jface.text.Position;

/**
 * A segment element.
 */
public class Segment {
	public String name;
	public Position position;
	public Segment parent;
	public ArrayList<Segment> children;

	public Segment(String name, Position position, Segment parent, ArrayList<Segment> children) {
		this.name= name;
		this.position= position;
		this.parent = parent;
		this.children = children;
	}

	public String toString() {
		return name;
	}
	
	public void setParent(Segment parent) {
		this.parent = parent;
	}
	
	public void setChildren(ArrayList<Segment> children) {
		this.children = children;
	}
	
	public Segment getParent() {
		return parent;
	}
	
	public ArrayList<Segment> getChildren() {
		return children;
	}
	
	public boolean hasChildren() {
		return (children!=null && children.size()>0);
	}
	
	public void setName(String name) {
		this.name = name;
	}
}
