package org.mcmas.ui.syntax;

import java.util.Hashtable;

public class CEAgent {
	private String name;
	private assignment[] assignments;
	private Hashtable<String, expression> vartable;
	private int length;
	
	public CEAgent(String name, assignment[] assignments) {
		this.name = name;
		this.assignments = assignments;
		if(assignments != null) {
			vartable = new Hashtable<String, expression>();
			for(int i=0; i<assignments.length; i++)
				vartable.put(assignments[i].get_var().get_variable_name(), assignments[i].get_var_value());
		}
		if(assignments == null)
			length = 1;
		else
			length = 1 + assignments.length;
	}
	
	public String getName() {
		return name;
	}
	
	public String toString() {
		String str = "Agent " + name + "\n";
		
		if(assignments != null)
			for(int i=0; i<assignments.length; i++) 
				str += "  " + assignments[i].toString() + "\n";
		
		return str;
	}
	
	public int numberOfLines() {
		return length;
	}
}
