package org.mcmas.ui.syntax;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

public class ExtendedGlobalState extends GlobalState {
	boolean[] value;
	boolean isSynchronized = false;
	boolean isChangedJ = false;
	boolean isVisible = false;
	
	public ExtendedGlobalState(Hashtable<String, LocalState> localStates) {
		super(localStates);
	}
	
	public ExtendedGlobalState(GlobalState g, Hashtable<String, bool_expression> is_evaluation) {
		super(g.localStates);
		value = new boolean[is_evaluation.size()];
		int j = 0;
		for(Enumeration<String> i = is_evaluation.keys(); i.hasMoreElements(); ) {
			String key = i.nextElement();
			bool_expression c = is_evaluation.get(key);
				value[j++] = c.evaluate2(this) ? true : false;
		}
	}
	
	public void setValue(boolean[] value) {
		if(this.value == null)
			this.value = new boolean[value.length];
		for(int i=0; i<value.length; i++)
			this.value[i] = value[i];
	}
	
	public void setSynchronized(boolean isSynchronized) {
		this.isSynchronized = isSynchronized;
	}
	
	public void setChangedJ(boolean isChangedJ) {
		this.isChangedJ = isChangedJ;
	}
	
	public boolean[] getValue() {
		return value;
	}
	
	public boolean getSynchronized() {
		return isSynchronized;
	}
	
	public boolean getChangedJ() {
		return isChangedJ;
	}
	
	public boolean isSameValue(ExtendedGlobalState g) {
		for(int i=0; i<value.length; i++)
			if(value[i] != g.value[i])
				return false;
		return true;
	}
	
	public void setVisible(ExtendedGlobalState g) {
		for(int i=0; i<value.length; i++)
			if(value[i] != g.value[i])
				isVisible = true;
	}
	
	public void setChangedJ(ExtendedGlobalState g, ArrayList<String> agnames) {
		for(int i=0; i<agnames.size(); i++) {
			String agname = agnames.get(i);
			LocalState l1 = localStates.get(agname);
			LocalState l2 = g.getGlobalState().get(agname);
			if(!l1.equalTo(l2)) {
				isChangedJ = true;
				break;
			}
		}
	}

	public String toString() {
		String str = "";
		
		for(Enumeration<String> i=localStates.keys(); i.hasMoreElements();) {
			String agentName = i.nextElement();
			LocalState lstate = localStates.get(agentName);
			str += agentName + "\n" + lstate.toString();
		}
		
		return str;
	}
	
	public String toString(ArrayList<basic_agent> agents) {
		String str = "";
		
		for(int i=0; i<agents.size(); i++) {
			String agentName = agents.get(i).get_name();
			LocalState lstate = localStates.get(agentName);
			if(lstate != null)
				str += agentName + "\n" + lstate.toString();
		}
		
		return str;
	}

}
