package org.mcmas.ui.syntax;

import java.util.Enumeration;
import java.util.Hashtable;

public class OneVariable {
	private basictype var;
	private expression value;
	
	public OneVariable(basictype var, expression value) {
		this.var = var;
		this.value = value;
	}
	
	public void setValue(expression value) {
		this.value = value;
	}
	
	public String getName() {
		if(var != null)
			return var.get_name();
		return null;
	}
	
	public expression getValue() {
		return value;
	}
	
	public OneVariable Clone() {
		return new OneVariable(var, value);
	}
	
	public String toString() {
		return "    " + var.get_name() + " = " + value.toString() + "\n";
	}
	
	public String toString1() {
		return value.toString()/* + "\n"*/;
	}
	
	public void toIntArray(int[] source) {
		int type = var.get_type();
		int count, iValue;
		if(type==1) {
			boolean v = ((bool_value)value).get_value();
			iValue = v ? 1 :0;
			count = 1;
		} else if(type==2) {
			int v = ((int_value)value).get_value();
			iValue = ((rangedint)var).get_value_index_int(v);
			count = ((rangedint)var).BDD_length();
		} else {
			String v = ((enum_value)value).get_value();
			iValue = ((enumerate)var).get_value_index_int(v);
			count = ((enumerate)var).BDD_length();
		}
		Util.leftShift(source, iValue, count);
	}
	
	public void replaceValue(expression value) {
		this.value = value;
	}
	
	public boolean equalTo(OneVariable v) {
		if(getName().compareTo(v.getName()) == 0) {
			int type = value.get_type();
			if(type == 1) {
				return ((bool_value)value).equalTo((bool_value)v.getValue());
			} else if(type == 2) {
				return ((int_value)value).equalTo((int_value)v.getValue());
			} else if(type == 3) {
				return ((enum_value)value).equalTo((enum_value)v.getValue());
			} 
		}
		
		return false;
	}
}
