package org.mcmas.ui.syntax;

import java.util.Hashtable;

import org.eclipse.jface.text.IDocument;

public class arithmetic_expression extends expression {
	expression[] operands;

	public arithmetic_expression(int o, expression e1, expression e2, int startline, int startcolumn, 
								 int endline, int endcolumn) {
		super(o, startline, startcolumn, endline, endcolumn);
		operands = new expression[2];
		operands[0] = e1;
		operands[1] = e2;
	}

	public expression get_operand(int i) {
		if (i > 1) {
			System.out.println("error: arithmetic operand " + i
					+ " does not exist!");
		} else if (operands[i] == null) {
			System.out.println("error: arithmetic operand " + i
					+ " is undefined!");
		}
		return (operands[i]);
	}

	public String toString() {
		String opstr = "";
		int op = get_type();
		if (op == 0)
			return operands[0].toString();
		else if (op == 5)
			opstr = "+";
		else if (op == 6)
			opstr = "-";
		else if (op == 7)
			opstr = "*";
		else if (op == 8)
			opstr = "/";
		return (operands[0].toString() + " " + opstr + " " + operands[1]
				.toString());
	}

	public String check_var_and_value(Hashtable<String, basictype> vars, IDocument document) {
		String errorMessage = "";
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		if (left == 0) {// left hand side is a variable
			variable var = (variable) operands[0];
			String vs = var.get_variable_name();
			/*Hashtable<String, basictype >::iterator p = vars.find(vs);
			if(p==vars.end()) {
			  System.out.println("        variable " + vs + " is not defined.");
			  flag = false;
			} else
			  ((variable )operands[0]).set_var_type(p.second);*/
			if(vars.containsKey(vs)) {
				basictype value = vars.get(vs);
				((variable) operands[0]).set_var_type(value);
			} else {
				errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
								"variable " + vs + " is not defined.\n";
			}
		} else if (left >= 5 && left <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[0]).check_var_and_value(vars, document);
		} else if (left != 2) { // lhs is not an integer
			//variable var = (variable) operands[0];
			errorMessage += Util.getErrorHeader(operands[0].startline, operands[0].startcolumn, 
					Util.getLength(document, operands[0].startline, operands[0].startcolumn, 
							operands[0].endline, operands[0].endcolumn)) + 
							"left hand side in" + toString() + " has a wrong type.\n";
		}

		if (right == 0) {// right hand side is a variable
			variable var = (variable) operands[1];
			String vs1 = var.get_variable_name();
			/*Hashtable<String, basictype >::iterator p1 = vars.find(vs1);
			if(p1==vars.end()) {
			  System.out.println("        variable " + vs1 + " is not defined.");
			  flag = false;
			} else
			  ((variable )operands[1]).set_var_type(p1.second);*/
			if(vars.containsKey(vs1)) {
				basictype value = vars.get(vs1);
				((variable) operands[1]).set_var_type(value);
			} else {
				errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs1.length()) + 
								"variable " + vs1 + " is not defined.\n";
			}
		} else if (right >= 5 && right <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[1]).check_var_and_value(vars, document);
		} else if (right != 2) { // lhs is not an integer
			//variable var = (variable) operands[1];
			errorMessage += Util.getErrorHeader(operands[1].startline, operands[1].startcolumn, 
					Util.getLength(document, operands[1].startline, operands[1].startcolumn, 
							operands[1].endline, operands[1].endcolumn)) + 
							"right hand side in" + toString() + " has a wrong type.\n";
		}
		return errorMessage;
	}

	public String check_var_and_value(Hashtable<String, basictype> obsvars, 
			Hashtable<String, basictype> vars, IDocument document) {
		String errorMessage = "";
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		if (left == 0) {// left hand side is a variable
			variable var = (variable) operands[0];
			String vs = var.get_variable_name();
			if (var.is_agent_name_null()) {
				/*Hashtable<String, basictype >::iterator p = vars.find(vs);
				if(p == vars.end()) {
				System.out.println("        variable " + vs + " is not defined.");
				flag = false;
				} else
				var.set_var_type(p.second);*/
				if(vars.containsKey(vs)) {
					basictype value = vars.get(vs);
					var.set_var_type(value);
				} else {
					errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
									"variable " + vs + " is not defined.\n";
				}
			} else if (var.get_agent_name() == "Environment") {
				/*Hashtable<String, basictype >::iterator p = obsvars.find(vs);
				if(p == obsvars.end()) {
				System.out.println("        variable " + vs + " is not defined.");
				flag = false;
				} else
				var.set_var_type(p.second);*/
				if(obsvars.containsKey(vs)) {
					basictype value = obsvars.get(vs);
					var.set_var_type(value);
				} else {
					errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
									"variable " + vs + " is not defined.\n";
				}
			} else {
				errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
								"variable " + vs + " is not defined.\n";
			}
		} else if (left >= 5 && left <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[0]).check_var_and_value(
					obsvars, vars, document);
		} else if (left != 2) { // lhs is not an integer
			errorMessage += Util.getErrorHeader(operands[0].startline, operands[0].startcolumn, 
								Util.getLength(document, operands[0].startline, operands[0].startcolumn, 
										operands[0].endline, operands[0].endcolumn)) + 
							"left hand side in" + toString() + " has a wrong type.";
		}

		if (right == 0) {// right hand side is a variable
			variable var = (variable) operands[1];
			String vs = var.get_variable_name();
			if (var.is_agent_name_null()) {
				/*Hashtable<String, basictype >::iterator p = vars.find(vs);
				if(p == vars.end()) {
				System.out.println("        variable " + vs + " is not defined.");
				flag = false;
				} else
				var.set_var_type(p.second);*/
				if(vars.containsKey(vs)) {
					basictype value = vars.get(vs);
					var.set_var_type(value);
				} else {
					errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
										" variable " + vs + " is not defined.\n";
				}
			} else if (var.get_agent_name() == "Environment") {
				/*Hashtable<String, basictype >::iterator p = obsvars.find(vs);
				if(p == obsvars.end()) {
				System.out.println("        variable " + vs + " is not defined.");
				flag = false;
				} else
				var.set_var_type(p.second);*/
				if(obsvars.containsKey(vs)) {
					basictype value = obsvars.get(vs);
					var.set_var_type(value);
				} else {
					errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
									"variable " + vs + " is not defined.\n";
				}
			} else {
				errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
								"variable " + vs + " is not defined.\n";
			}
		} else if (right >= 5 && right <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[1]).check_var_and_value(
					obsvars, vars, document);
		} else if (right != 2) { // lhs is not an integer
			errorMessage += Util.getErrorHeader(operands[1].startline, operands[1].startcolumn, 
					Util.getLength(document, operands[1].startline, operands[1].startcolumn, 
							operands[1].endline, operands[1].endcolumn)) + 
							"right hand side in" + toString() + " has a wrong type.\n";
		}
		return errorMessage;
	}

	public String check_var_and_value1(Hashtable<String, Hashtable<String, basictype>> vars, IDocument document) {
		String errorMessage = "";
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		if (left == 0) {// left hand side is a variable
			variable var = (variable) operands[0];
			String vs = var.get_variable_name();
			String ag_name = var.get_agent_name();
			/*Hashtable<String, Hashtable<String, basictype > >::iterator gp = vars.find(ag_name);
			if(gp==vars.end()) {
			  System.out.println("    undefined agent " + ag_name);
			  return false;
			}
			Hashtable<String, basictype >::iterator p = gp.second.find(vs);
			if(p==gp.second.end()) {
			System.out.println("        variable " + vs + " is not defined in agent " + ag_name);
			flag = false;
			} else
			  var.set_var_type(p.second);*/
			if(vars.containsKey(ag_name)) {
				Hashtable<String, basictype> value = vars.get(ag_name);
				if(value.containsKey(vs)) {
					basictype value1 = value.get(vs);
					var.set_var_type(value1);
				} else {
					errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
									"variable " + vs + " is not defined in agent " + ag_name + "\n";
				}
			} else {
				return Util.getErrorHeader(var.agstartline, var.agstartcolumn, ag_name.length()) + 
						"undefined agent " + ag_name + "\n";
			}	
		} else if (left >= 5 && left <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[0]).check_var_and_value1(vars, document);
		} else if (left != 2) { // lhs is not an integer
			//variable var = (variable) operands[0];
			errorMessage += Util.getErrorHeader(operands[0].startline, operands[0].startcolumn,
					Util.getLength(document, operands[0].startline, operands[0].startcolumn, 
							operands[0].endline, operands[0].endcolumn)) + 
					"left hand side in" + toString() + " has a wrong type.\n";
		}

		if (right == 0) {// left hand side is a variable
			variable var1 = (variable) operands[1];
			String vs1 = var1.get_variable_name();
			String ag_name = var1.get_agent_name();
			/*Hashtable<String, Hashtable<String, basictype > >::iterator gp = vars.find(ag_name);
			if(gp==vars.end()) {
			  System.out.println("    undefined agent " + ag_name);
			  return false;
			}
			Hashtable<String, basictype >::iterator p = gp.second.find(vs1);
			if(p==gp.second.end()) {
			  System.out.println("        variable " + vs1 + " is not defined in agent " + ag_name);
			  flag = false;
			} else
			  var1.set_var_type(p.second);*/
			if(vars.containsKey(ag_name)) {
				Hashtable<String, basictype> value = vars.get(ag_name);
				if(value.containsKey(vs1)) {
					basictype value1 = value.get(vs1);
					var1.set_var_type(value1);
				} else {
					errorMessage += Util.getErrorHeader(var1.startline, var1.startcolumn, vs1.length()) + 
									"variable " + vs1 + " is not defined in agent " + ag_name + "\n";
				}
			} else {
				return Util.getErrorHeader(var1.agstartline, var1.agstartcolumn, ag_name.length()) + 
				"undefined agent " + ag_name + "\n";
			}
		} else if (right >= 5 && right <= 8) {//lhs is an arithmetic expression
			errorMessage += ((arithmetic_expression) operands[1])
					.check_var_and_value1(vars, document);
		} else if (right != 2) { // lhs is not an integer
			//variable var = (variable) operands[1];
			errorMessage += Util.getErrorHeader(operands[1].startline, operands[1].startcolumn,
					Util.getLength(document, operands[1].startline, operands[1].startcolumn, 
							operands[1].endline, operands[1].endcolumn)) + 
					"left hand side in" + toString() + " has a wrong type.\n";
		}
		return errorMessage;
	}
	
	public int evaluate(String agentName, GlobalState gstate) {
		int ltype = operands[0].get_type();
		int rtype = operands[1].get_type();
		int lint;
		int rint;
		
		if(ltype == 0) { // left hand side is a variable
			variable lvar = (variable)operands[0];
			String agentName1 = lvar.get_agent_name();
			if(agentName1 == null || Util.isEmpty(agentName1))
				agentName1 = agentName;
			int_value lvalue = (int_value)gstate.getValue(agentName1, lvar.get_variable_name());
			lint = lvalue.get_value();
		} else if(ltype == 2) { // left hand side is an integer
			lint = ((int_value)operands[0]).get_value();
		} else { // left hand side is an arithmetic expression
			lint = ((arithmetic_expression)operands[0]).evaluate(agentName, gstate);
		}
		
		if(rtype == 0) { // right hand side is a variable
			variable rvar = (variable)operands[1];
			String agentName2 = rvar.get_agent_name();
			if(agentName2 == null || Util.isEmpty(agentName2))
				agentName2 = agentName;
			int_value rvalue = (int_value)gstate.getValue(agentName2, rvar.get_variable_name());
			rint = rvalue.get_value();
		} else if(rtype == 2) { // right hand side is an integer
			rint = ((int_value)operands[1]).get_value();
		} else { // right hand side is an arithmetic expression
			rint = ((arithmetic_expression)operands[1]).evaluate(agentName, gstate);
		}
		
		int op = get_type();
		if(op == 5) // addition
			return lint + rint;
		else if(op == 6) // subtraction
			return lint - rint;
		else if(op == 7) // multiplication
			return lint * rint;
		else // division
			return lint / rint;
	}
}
