package org.mcmas.ui.syntax;

import java.util.Hashtable;
import java.util.TreeSet;

import org.eclipse.jface.text.IDocument;

public class assignment {
	variable var;
	expression var_value;

	public assignment(String name, int line, int column, expression value) {
		//agent_name = NULL;
		//var_name = name;
		var = new variable(name, line, column);
		var_value = value;
	}

	public variable get_var() {
		return var;
	}

	public expression get_var_value() {
		return var_value;
	}

	public String toString() {
		return var.toString() + " = " + var_value.toString();
	}

	public String check_var_and_value(Hashtable<String, basictype> obsvars,
			Hashtable<String, basictype> vars, IDocument document) {
		int right = var_value.get_type(); // right hand side
		int right1 = right;
		String vs = var.get_variable_name();
		basictype p = vars.get(vs);
		if (p == null) {// the variable is not defined
			return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
				"variable " + vs + " is not defined.\n";
		}

		// add a link in variable to its type
		var.set_var_type(p);
		basictype p1 = null;
		String vs1 = "";
		if (right == 0) {
			variable v2 = ((variable) var_value);
			vs1 = v2.get_variable_name();
			if (((variable) var_value).is_agent_name_null()) {
				p1 = vars.get(vs1);
				if (p1 != null) {// the variable is a local variable 
					right = p1.get_type();
					((variable) var_value).set_var_type(p1);
				}
			} else {
				String ag_name = ((variable) var_value).get_agent_name();
				if (ag_name == "Environment") {
					p1 = obsvars.get(vs1);
					if (p1 != null) {// the variable is a global variable 
						right = p1.get_type();
						((variable) var_value).set_var_type(p1);
					}
				}
			}
		}
		int t1 = p.get_type(); //variable's type
		if ((t1 != right && right < 5 && !(t1 == 3 && right == 0))
				|| ((t1 == 1 || t1 == 3) && right >= 5)) {
			return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
					"variable " + vs + " has a wrong typed value.";
		}
		if (t1 == 1) // boolean
			return "";
		else if (t1 == 2) {
			if (right1 == 0) { // rangedint
				int ub = ((rangedint) (p)).get_upperbound();
				int lb = ((rangedint) (p)).get_lowerbound();
				int ub1 = ((rangedint) (p1)).get_upperbound();
				int lb1 = ((rangedint) (p1)).get_lowerbound();
				if (ub < lb1 || ub1 < lb) {
					return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
							"variable " + vs1 + " cannot be assignment to variable " + vs + ".";
				} else
					return "";
			} else if (right1 == 2) {// int_value
				if (((rangedint) (p)).is_valid_value(((int_value) var_value)
						.get_value()))
					return "";
				else {
					return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
							"variable " + vs + " has a wrong integer value.";
				}
			} else {//arithmetic expression
				return ((arithmetic_expression) var_value).check_var_and_value(obsvars, vars, document);
			}
		} else if (t1 == 3) {// enum
			if (right == 0) { // an enum value
				if (((enumerate) (p)).is_valid_value(vs1)) {
					variable v2 = ((variable) var_value);
					enum_value tmp = new enum_value(new String(vs1), v2.startline, v2.startcolumn);
					var_value = tmp; // change it to enum_value
					return "";
				} else {
					return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) +
								"variable " + vs + " has a wrong enum value '" + vs1 + "'.";
				}
			} else { // an enumerate variable
				TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
				TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
				if (s1.size() == s2.size() && s2.containsAll(s1)) {// same size
					return "";
				} else {
					return Util.getErrorHeader(var.startline, var.startcolumn, vs.length()) + 
							"variables " + vs + " and " + vs1 + " do not have the same enumerate type.";
				}
			}
		}
		return "";
	}
}
