package org.mcmas.ui.syntax;

import java.util.ArrayList;

public class basictype {
	protected String name;
	protected int type; // 1: boolean, 2: rangedint, 3: enumerate
	protected int index_begin; // the index of bdd variables in the vector
	protected int index_end;
	public int line;
	public int column;
	public ArrayList<logic_expression> lexprs; 
	
	public basictype(String n, int line, int column) {
		name = n;
		type = 1;
		index_begin = -1;
		index_end = -1;
		this.line = line;
		this.column = column;
		this.lexprs = null;
	}

	public basictype(String n, int t, int line, int column) {
		name = n;
		type = t;
		index_begin = -1;
		index_end = -1;
		this.line = line;
		this.column = column;
	}

	public String get_name() {
		if (name == null) 
			System.out.println("type name is unknown");
		return name;
	}

	public int get_type() {
		return type;
	}

	public String toString() {
		return name + ": boolean";
	}

	public int BDD_length() {
		return 1;
	}

	public void set_index_begin(int i) {
		index_begin = i;
	}

	public void set_index_end(int i) {
		index_end = i;
	}

	public int get_index_begin() {
		return index_begin;
	}

	public int get_index_end() {
		return index_end;
	}

	public void print_value_index() {
		System.out.println("true: 1");
		System.out.println("false: 0");
	}
	
	/**
	 * Generate logic expressions for all possible values
	 * @param agentName
	 * @return the set of logic expressions
	 */
	public ArrayList<logic_expression> getLogicExpressions(String agentName) {
		if(lexprs == null) {
			variable var = new variable(agentName, get_name(), 0, 0, 0, 0);
			var.set_var_type(this);
			lexprs = new ArrayList<logic_expression>();
			lexprs.add(new logic_expression(0, var, new bool_value(true, 0, 0)));
			lexprs.add(new logic_expression(0, var, new bool_value(false, 0, 0)));
		}
		return lexprs;
	}
}
