package org.mcmas.ui.syntax;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.TreeSet;

public class enumerate extends basictype{
	private TreeSet<String> enumvalue;
	private Hashtable<String, boolean[]> value_index;
	private Hashtable<String, Integer> value_index_int;
	private int bdd_length;

	public enumerate(String n, TreeSet<String> s, int line, int column) {
		super(n, 3, line, column);
		enumvalue = s;
		value_index = new Hashtable<String, boolean[]>();
		bdd_length = enumvalue == null ? 0 : Util.log_2(enumvalue.size());
		set_value_index();
	}

	public TreeSet<String> get_enumvalue() {
		return enumvalue;
	}

	boolean is_valid_value(String s) {
		if (enumvalue == null) {
			System.out.println("enum list is unknown");
		}
		return enumvalue.contains(s);
		/* Iterator<String> i = enumvalue.iterator();
		while (i.hasNext()) {
			String element = (String) i.next();
			if (element.compareTo(s) == 0)
				return true;
		}
		return false;*/
	}

	public String toString() {
		String str = ": { ";
		int k = 0;
		int j = enumvalue.size() - 1;
		Iterator<String> i = enumvalue.iterator();
		while (i.hasNext()) {
			String element = (String) i.next();
			if (k == j)
				str += element + " ";
			else
				str += element + ", ";
			k++;
		}
		str += "}";
		return get_name() + str;
	}

	public int BDD_length() {
		return bdd_length;
	}

	public void set_value_index() {
		int size = BDD_length();
		boolean[] base = new boolean[size];
		for (int i = 0; i < size; i++)
			base[i] = false;
		Iterator<String> i = enumvalue.iterator();
		while (i.hasNext()) {
			String element = (String) i.next();
			boolean[] temp = new boolean[size];
			for (int j = 0; j < size; j++)
				temp[j] = base[j];
			value_index.put(element, temp);
			for (int j = size - 1; j >= 0; j--) {
				if (base[j])
					base[j] = false;
				else {
					base[j] = true;
					break;
				}
			}
		}
	}
	
	public void set_value_index_int() {
		if(value_index_int == null)
			value_index_int = new Hashtable<String, Integer>();

		Iterator<String> i = enumvalue.iterator();
		int count = 0;
		while (i.hasNext()) {
			String element = (String) i.next();
			value_index_int.put(element, new Integer(count));
			count++;
		}
	}

	public void print_value_index() {
		for (Enumeration<String> i = value_index.keys(); i.hasMoreElements();) {
			String key = i.nextElement();
			boolean[] value = value_index.get(key);
			System.out.println(key + ": ");
			for (int k = 0; k < value.length; k++)
				System.out.print(value[k] ? "1" : "0");
			System.out.println();
		}
	}

	public boolean[] get_value_index(String key) {
		if (value_index != null) {
			return value_index.get(key);
		}
		return null;
	}
	
	public int get_value_index_int(String key) {
		if (value_index_int == null)
			set_value_index_int();
		return value_index_int.get(key).intValue();
	}

	public String find_value_by_index(boolean[] index) {
		for (Enumeration<String> i = value_index.keys(); i.hasMoreElements();) {
			String key = i.nextElement();
			boolean[] value = value_index.get(key);
			boolean flag = true;
			for (int k = 0; k < value.length; k++)
				if (value[k] != index[k]) {
					flag = false;
					break;
				}
			if (flag)
				return key;
		}
		return "";
	}
	
	/**
	 * Generate logic expressions for all possible values
	 */
	public ArrayList<logic_expression> getLogicExpressions(String agentName) {
		if(lexprs == null) {
			variable var = new variable(agentName, get_name(), 0, 0, 0, 0);
			var.set_var_type(this);
			lexprs = new ArrayList<logic_expression>();
			for(Iterator<String> i = enumvalue.iterator(); i.hasNext();) {
				enum_value b = new enum_value(i.next(), 0, 0);
				lexprs.add(new logic_expression(0, var, b));
			}
		}
		return lexprs;
	}
}
