package org.mcmas.ui.syntax;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.TreeSet;

public class evolution_line {
	ArrayList<assignment> assignments;
	bool_expression condition;

	public evolution_line(ArrayList<assignment> a, bool_expression c) {
		assignments = a;
		condition = c;
	}

	public ArrayList<assignment> get_assignments() {
		return assignments;
	}

	public bool_expression get_condition() {
		return condition;
	}

	public String toString() {
		String str = "";
		for (int i = 0; i < assignments.size(); i++)
			str += assignments.get(i).toString()
					+ (i == assignments.size() - 1 ? " " : " and ");
		str += " if " + condition.toString();
		return str;
	}
	
	public String check_double_assignment() {
		String errorMessage = "";
		Hashtable<String, variable> reassigned = new Hashtable<String, variable>();
		for (int j = 0; j < assignments.size() - 1; j++) {
			String var_name = assignments.get(j).get_var().get_variable_name();
			for (int k = j + 1; k < assignments.size(); k++) {
				variable var = assignments.get(k).get_var();
				String var_name1 = assignments.get(k).get_var()
						.get_variable_name();
				if (var_name == var_name1) {
					reassigned.put(var_name, var);
					break;
				}
			}
		}
		if (reassigned.size() > 0) {
			for (Enumeration<String> i = reassigned.keys(); i.hasMoreElements();) {
				String key = i.nextElement();
				variable var = reassigned.get(key);
				errorMessage += Util.getErrorHeader(var.startline, var.startcolumn, key.length()) +
								"variable " + key + " is assigned twice or more\n";
			}
		}
		return errorMessage;
	}

}
