package org.mcmas.ui.syntax;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.TreeSet;

import org.eclipse.jface.text.IDocument;

public class logic_expression {
	int op; // 0: =, 1: <>, 2: <, 3: <=, 4: >, 5: >=
	expression[] operands;
	public int opStartline;
	public int opStartcolumn;
	public int opLength;

	public logic_expression(int o, expression e1, expression e2, 
			int opStartline, int opStartcolumn, int opLength) {
		op = o;
		operands = new expression[2];
		operands[0] = e1;
		operands[1] = e2;
		this.opStartline = opStartline;
		this.opStartcolumn = opStartcolumn;
		this.opLength = opLength;
	}

	public logic_expression(int o, expression e1, expression e2) {
		op = o;
		operands = new expression[2];
		operands[0] = e1;
		operands[1] = e2;
		this.opStartline = 0;
		this.opStartcolumn = 0;
		this.opLength = 0;
	}

	int get_op() {
		return op;
	}

	public expression get_operand(int i) {
		if (i > 1) {
			System.out
					.println("error: logic operand " + i + " does not exist!");
		} else if (operands[i] == null) {
			System.out.println("error: logic operand " + i + " is undefined!");
		}
		return (operands[i]);
	}

	public String toString() {
		String opstr = "";
		if (op == 0)
			opstr = "=";
		else if (op == 1)
			opstr = "<>";
		else if (op == 2)
			opstr = "<";
		else if (op == 3)
			opstr = "<=";
		else if (op == 4)
			opstr = ">";
		else if (op == 5)
			opstr = ">=";
		return operands[0].toString() + opstr + operands[1].toString();
	}

	public String check_var_and_value(Hashtable<String, basictype> vars,
			IDocument document) {
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		boolean left_var = true;
		boolean right_var = true;

		if (left == 0) {// left hand side is a variable, or an enumeration value
			variable v1 = (variable) operands[0];
			String vs = v1.get_variable_name();
			/*
			 * Hashtable<String, basictype >::iterator p = vars.find(vs);
			 * if(p==vars.end()) left_var = false;
			 */

			basictype p = null;
			if (vars.containsKey(vs))
				p = vars.get(vs);
			else
				left_var = false;
			if (right == 0) {// right hand side could be a variable or a
								// enumeration value
				variable v2 = (variable) operands[1];
				String vs1 = v2.get_variable_name();
				/*
				 * Hashtable<String, basictype >::iterator p1 = vars.find(vs1);
				 * if(p1==vars.end()) right_var = false;
				 */
				basictype p1 = null;
				if (vars.containsKey(vs1))
					p1 = vars.get(vs1);
				else
					right_var = false;
				if (left_var && right_var) {// both sides are variables
					// check if both sides have the same type.
					int t1 = p.get_type(); // lhs' type
					int t2 = p1.get_type(); // rhs' type
					if (t1 == t2) { // same type
						if (t1 == 3) {// enumeration type
							if(op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}
							TreeSet<String> s1 = ((enumerate) (p))
									.get_enumvalue();
							TreeSet<String> s2 = ((enumerate) (p1))
									.get_enumvalue();
							if (s1.size() == s2.size() && s2.containsAll(s1)) {// same
																				// size
								// add a link in variable to its type
								((variable) operands[0]).set_var_type(p);
								((variable) operands[1]).set_var_type(p1);
								return "";
							} else {
								return Util.getErrorHeader(v1.startline,
										v1.startcolumn, vs.length())
										+ vs
										+ " and "
										+ vs1
										+ " do not have the same enumeration type.\n";
							}

						} else {
							if(t1 == 1 && op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}
							((variable) operands[0]).set_var_type(p);
							((variable) operands[1]).set_var_type(p1);
							return "";
						}
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " and "
								+ vs1
								+ " have different type.\n";
					}
				} else if (left_var && !right_var) {// lhs is a variable and rhs
													// is an enumeration value
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}					
					int t1 = p.get_type(); // lhs' type
					if (t1 == 3) {// lhs must be enumeration
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							// change the rhs to be an enumeration value
							operands[1] = new enum_value(new String(vs1),
									operands[1].startline,
									operands[1].startcolumn);
							return "";
						} else {
							return Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs + " must have an enumeration type.\n";
					}
				} else if (!left_var && right_var) {// lhs is an enumeration value
													// and rhs is a variable
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}					
					int t2 = p1.get_type(); // rhs' type
					if (t2 == 3) {// rhs must be enumeration
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in rhs to its type
							((variable) operands[1]).set_var_type(p1);
							// change the lhs to be an enumeration value
							operands[0] = new enum_value(new String(vs),
									operands[0].startline,
									operands[0].startcolumn);
							return "";
						} else {
							return Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1
									+ " does not have the value "
									+ vs
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1 + " must have an enumeration type.\n";
					}
				} else {
					return Util.getErrorHeader(v1.startline, v1.startcolumn, vs
							.length())
							+ vs + " or " + vs1 + " must be a variable.\n";
				}
			} else if (left_var) {
				left = p.get_type();
				if (right == 1) {// right hand side is a boolean value
					if (left != 1) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[0]).set_var_type(p);
						return "";
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (right == 2) {// right hand side is an integer
					if (left != 2) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a bounded integer variable.\n";
					}
					((variable) operands[0]).set_var_type(p);
					return "";
				} else if (right == 3) {// right hand side is an enumeration
										// value. It cannot happen. But we still
										// check it.
					//System.out.println("        enumeration value cannot appear here.\n");
					if (left != 3) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not an enumeration variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs1 = ((enum_value) operands[1]).get_value();
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return "";
						} else {
							return Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// right hand side is an arithmetic expression
					if (p.get_type() == 2) {
						String str = ((arithmetic_expression) operands[1])
								.check_var_and_value(vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return "";
						} else
							return str
									+ Util.getErrorHeader(v1.startline,
											v1.startcolumn, vs.length())
									+ vs
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[1])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[1])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return Util.getErrorHeader(v1.startline, v1.startcolumn, vs
						.length())
						+ vs + " must be a variable.\n";
			}
		} else if (right == 0) {// right hand side is a variable
			variable v2 = ((variable) operands[1]);
			String vs1 = v2.get_variable_name();
			basictype p1 = vars.get(vs1);
			if (p1 != null) {
				right = p1.get_type();
				if (left == 1) {// left hand side is a boolean value
					if (right != 1) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[1]).set_var_type(p1);
						return "";
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (left == 2) {// left hand side is an integer
					if (right != 2) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					((variable) operands[1]).set_var_type(p1);
					return "";
				} else if (left == 3) {// left hand side is an enumeration value.
										// It cannot happen. But we still check
										// it.
					if (right != 3) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					//System.out.println("        enumeration value cannot appear here.\n");
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs = ((enum_value) operands[0]).get_value();
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return "";
						} else {
							return Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1
									+ " does not have the value "
									+ vs
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// left hand side is an arithmetic expression
					if (p1.get_type() == 2) {
						String str = ((arithmetic_expression) operands[0])
								.check_var_and_value(vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return "";
						} else
							return str
									+ Util.getErrorHeader(v2.startline,
											v2.startcolumn, vs1.length())
									+ vs1
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[0])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[0])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return Util.getErrorHeader(v2.startline, v2.startcolumn, vs1
						.length())
						+ vs1 + " must be a variable.\n";
			}
		} else if (left >= 5 && left <= 8) { // left hand side is an
												// arithmetic expression
			if (right == 2) // rhs is an integer
				return ((arithmetic_expression) operands[0])
						.check_var_and_value(vars, document);
			else if (right >= 5 && right <= 8) // rhs is an arithmetic
												// expression
				return ((arithmetic_expression) operands[0])
						.check_var_and_value(vars, document)
						+ ((arithmetic_expression) operands[1])
								.check_var_and_value(vars, document);
			else {
				return Util.getErrorHeader(operands[1].startline,
						operands[1].startcolumn, Util.getLength(document,
								operands[1].startline, operands[1].startcolumn,
								operands[1].endline, operands[1].endcolumn))
						+ "right hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		} else if (right >= 5 && right <= 8) { // right hand side is an
												// arithmetic expression
			if (left == 2) // lhs is an integer
				return ((arithmetic_expression) operands[1])
						.check_var_and_value(vars, document);
			else {
				return Util.getErrorHeader(operands[1].startline,
						operands[1].startcolumn, Util.getLength(document,
								operands[1].startline, operands[1].startcolumn,
								operands[1].endline, operands[1].endcolumn))
						+ "left hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		}
		return Util.getErrorHeader(operands[0].startline,
				operands[0].startcolumn, Util.getLength(document,
						operands[0].startline, operands[0].startcolumn,
						operands[1].endline, operands[1].endcolumn))
				+ "wrong logic expression " + toString() + "\n";
	}

	public String check_evolution(Hashtable<String, basictype> obsvars,
			Hashtable<String, basictype> vars, String agent_name,
			Hashtable<String, basic_agent> global_actions, IDocument document) {
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		boolean left_var = true;
		boolean right_var = true;

		if (left == 4) {
			String act_name = ((variable) operands[1]).get_variable_name();
			boolean f = ((laction) operands[0]).is_agent_name_null();
			String ag_name = f ? agent_name : ((laction) operands[0])
					.get_agent_name();

			basic_agent p = global_actions.get(ag_name);
			if (p == null) {
				if (f)
					return Util.getErrorHeader(operands[1].startline,
							operands[1].startcolumn, act_name.length())
							+ "action "
							+ act_name
							+ " is not found in agent "
							+ ag_name + "\n";
				else {
					laction la = (laction) operands[0];
					return Util.getErrorHeader(la.agstartline,
							la.agstartcolumn, ag_name.length())
							+ "agent " + ag_name + " is not defined.\n";
				}
			}

			if (f) {
				((laction) operands[0]).set_agent_name(new String(agent_name));
				((laction) operands[0]).set_agent((p));
			} else
				((laction) operands[0]).set_agent((p));

			TreeSet<String> acts = (p).get_actions();
			if (!acts.contains(act_name)) {
				return Util.getErrorHeader(operands[1].startline,
						operands[1].startcolumn, act_name.length())
						+ "action "
						+ act_name
						+ " is not found in agent "
						+ ag_name + "\n";
			} else
				return "";
		} else if (left == 0) {// left hand side is a variable, or an enumeration
								// value
			variable v1 = ((variable) operands[0]);
			String vs = v1.get_variable_name();
			basictype p = null;
			if (v1.is_agent_name_null()) {// local variable
				p = vars.get(vs);
				if (p == null)
					left_var = false;
			} else {
				p = obsvars.get(vs);
				if (p == null)
					left_var = false;
			}
			if (right == 0) {// right hand side could be a variable or a
								// enumeration value
				variable v2 = ((variable) operands[1]);
				String vs1 = v2.get_variable_name();
				basictype p1;
				if (v2.is_agent_name_null()) {// local variable
					p1 = vars.get(vs1);
					if (p1 == null)
						right_var = false;
				} else {
					p1 = obsvars.get(vs1);
					if (p1 == null)
						right_var = false;
				}
				if (left_var && right_var) {// both sides are variables
					// check if both sides have the same type.
					int t1 = p.get_type(); // lhs' type
					int t2 = p1.get_type(); // rhs' type
					if (t1 == t2) { // same type
						if (t1 == 3) {// enumeration type
							if(op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}							
							TreeSet<String> s1 = ((enumerate) (p))
									.get_enumvalue();
							TreeSet<String> s2 = ((enumerate) (p1))
									.get_enumvalue();
							if (s1.size() == s2.size() && s2.containsAll(s1)) {// same
																				// size

								// add a link in variable to its type
								((variable) operands[0]).set_var_type(p);
								((variable) operands[1]).set_var_type(p1);
								return "";
							} else {
								return Util.getErrorHeader(v1.startline,
										v1.startcolumn, vs.length())
										+ vs
										+ " and "
										+ vs1
										+ " do not have the same enumeration type.\n";
							}
						} else {
							if(t1 == 1 && op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}							
							((variable) operands[0]).set_var_type(p);
							((variable) operands[1]).set_var_type(p1);
							return "";
						}
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " and "
								+ vs1
								+ " have different type.\n";
					}
				} else if (left_var && !right_var) {// lhs is a variable and rhs
													// is an enumeration value
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
					int t1 = p.get_type(); // lhs' type
					if (t1 == 3) {// lhs must be enumeration
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							// change the rhs to be an enumeration value
							operands[1] = new enum_value(new String(vs1),
									operands[1].startline,
									operands[1].startcolumn);
							return "";
						} else {
							return Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs + " must have an enumeration type.\n";
					}
				} else if (!left_var && right_var) {// lhs is an enumeration value
													// and rhs is a variable
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}					
					int t2 = p1.get_type(); // rhs' type
					if (t2 == 3) {// rhs must be enumeration
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in rhs to its type
							((variable) operands[1]).set_var_type(p1);
							// change the lhs to be an enumeration value
							operands[0] = new enum_value(new String(vs),
									operands[0].startline,
									operands[0].startcolumn);
							return "";
						} else {
							return Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1
									+ " does not have the value "
									+ vs
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1 + " must have an enumeration type.\n";
					}
				} else {
					return Util.getErrorHeader(v1.startline, v1.startcolumn, vs
							.length())
							+ vs + " or " + vs1 + " must be a variable.\n";
				}
			} else if (left_var) {
				left = p.get_type();
				if (right == 1) {// right hand side is a boolean value
					if (left != 1) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[0]).set_var_type(p);
						return "";
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (right == 2) {// right hand side is an integer
					if (left != 2) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a bounded integer variable.\n";
					}
					((variable) operands[0]).set_var_type(p);
					return "";
				} else if (right == 3) {// right hand side is an enumeration
										// value. It cannot happen. But we still
										// check it.
					//System.out.println("enumeration value cannot appear here.\n");
					if (left != 3) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not an enumeration variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs1 = ((enum_value) operands[1]).get_value();
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return "";
						} else {
							return Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// right hand side is an arithmetic expression
					if (p.get_type() == 2) {
						String str = ((arithmetic_expression) operands[1])
								.check_var_and_value(obsvars, vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return "";
						} else
							return str
									+ Util.getErrorHeader(v1.startline,
											v1.startcolumn, vs.length())
									+ vs
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[1])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[1])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return Util.getErrorHeader(v1.startline, v1.startcolumn, vs
						.length())
						+ vs + " must be a variable.\n";
			}
		} else if (right == 0) {// right hand side is a variable
			variable v2 = ((variable) operands[1]);
			String vs1 = ((variable) operands[1]).get_variable_name();
			basictype p1 = null;
			if (v2.is_agent_name_null()) {// local variable
				p1 = vars.get(vs1);
				if (p1 == null)
					right_var = false;
			} else {
				p1 = obsvars.get(vs1);
				if (p1 == null)
					right_var = false;
			}
			if (right_var) {
				right = p1.get_type();
				if (left == 1) {// left hand side is a boolean value
					if (right != 1) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[1]).set_var_type(p1);
						return "";
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (left == 2) {// left hand side is an integer
					if (right != 2) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					((variable) operands[1]).set_var_type(p1);
					return "";
				} else if (left == 3) {// left hand side is an enumeration value.
										// It cannot happen. But we still check
										// it.
					//System.out.println("        enumeration value cannot appear here.\n");
					if (right != 3) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs = ((enum_value) operands[0]).get_value();
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return "";
						} else {
							return Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1
									+ " does not have the value "
									+ vs
									+ "\n";
						}
					} else {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// left hand side is an arithmetic expression
					if (p1.get_type() == 2) {
						String str = ((arithmetic_expression) operands[0])
								.check_var_and_value(obsvars, vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return "";
						} else
							return str
									+ Util.getErrorHeader(v2.startline,
											v2.startcolumn, vs1.length())
									+ vs1
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[1])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[0])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return Util.getErrorHeader(v2.startline, v2.startcolumn, vs1
						.length())
						+ vs1 + " must be a variable.\n";
			}
		} else if (left >= 5 && left <= 8) { // left hand side is an
												// arithmetic expression
			if (right == 2) // rhs is an integer
				return ((arithmetic_expression) operands[0])
						.check_var_and_value(obsvars, vars, document);
			else if (right >= 5 && right <= 8) // rhs is an arithmetic
												// expression
				return ((arithmetic_expression) operands[0])
						.check_var_and_value(obsvars, vars, document)
						+ ((arithmetic_expression) operands[1])
								.check_var_and_value(obsvars, vars, document);
			else {
				return Util.getErrorHeader(operands[1].startline,
						operands[1].startcolumn, Util.getLength(document,
								operands[1].startline, operands[1].startcolumn,
								operands[1].endline, operands[1].endcolumn))
						+ "right hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		} else if (right >= 5 && right <= 8) { // right hand side is an
												// arithmetic expression
			if (left == 2) // lhs is an integer
				return ((arithmetic_expression) operands[1])
						.check_var_and_value(obsvars, vars, document);
			else {
				return Util.getErrorHeader(operands[0].startline,
						operands[0].startcolumn, Util.getLength(document,
								operands[0].startline, operands[0].startcolumn,
								operands[0].endline, operands[0].endcolumn))
						+ "left hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		}

		return Util.getErrorHeader(operands[0].startline,
				operands[0].startcolumn, Util.getLength(document,
						operands[0].startline, operands[0].startcolumn,
						operands[1].endline, operands[1].endcolumn))
				+ "illegal logic expression: " + toString() + ".\n";
	}

	public String check_global_consistency(
			Hashtable<String, Hashtable<String, basictype>> vars,
			IDocument document) {
		int left = operands[0].get_type(); // left hand side
		int right = operands[1].get_type(); // right hand side
		boolean left_var = true;
		boolean right_var = true;
		String errorMessage = "";
		
		if (left == 0) {// left hand side is a variable, or an enumeration value
			variable v1 = ((variable) operands[0]);
			String vs = v1.get_variable_name();
			boolean left_defined = true;
			basictype p = null;
			if (v1.is_agent_name_null())
				left_var = false;
			else {
				String ag_name = v1.get_agent_name();
				Hashtable<String, basictype> gp = vars.get(ag_name);
				if (gp == null) {
					errorMessage += Util.getErrorHeader(v1.agstartline,
							v1.agstartcolumn, ag_name.length())
							+ "undefined agent " + ag_name + "\n";
					left_defined = false;
				} else {
					p = gp.get(vs);
					if (p == null) {// the variable is not defined
						errorMessage += Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ "variable " + vs
								+ " is not defined in agent " + ag_name + "\n";
						left_defined = false;
					}
				}
			}
			if (right == 0) {// right hand side could be a variable or a
								// enumeration value
				variable v2 = ((variable) operands[1]);
				String vs1 = v2.get_variable_name();
				boolean right_defined = true;
				basictype p1 = null;
				if (v2.is_agent_name_null())
					right_var = false;
				else {
					String ag_name = v2.get_agent_name();
					Hashtable<String, basictype> gp = vars.get(ag_name);
					if (gp == null) {
						errorMessage += Util.getErrorHeader(v2.agstartline,
								v2.agstartcolumn, ag_name.length()) +
								"undefined agent " + ag_name + "\n";
						right_defined = false;
					} else {
						p1 = gp.get(vs1);
						if (p1 == null) {// the variable is not defined
							errorMessage += Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ "variable " + vs1
									+ " is not defined in agent " + ag_name + "\n";
							right_defined = false;
						}
					}
				}
				if (!left_defined || !right_defined)
					return errorMessage;
				if (left_var && right_var) {// both sides are variables
					// check if both sides have the same type.
					int t1 = p.get_type(); // lhs' type
					int t2 = p1.get_type(); // rhs' type
					if (t1 == t2) { // same type
						if (t1 == 3) {// enumeration type
							if(op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}					
							TreeSet<String> s1 = ((enumerate) (p))
									.get_enumvalue();
							TreeSet<String> s2 = ((enumerate) (p1))
									.get_enumvalue();
							if (s1.size() == s2.size() && s2.containsAll(s1)) {// same
																				// size
								// add a link in variable to its type
								((variable) operands[0]).set_var_type(p);
								((variable) operands[1]).set_var_type(p1);
								return errorMessage;
							} else {
								return errorMessage + Util.getErrorHeader(v1.startline,
										v1.startcolumn, vs.length())
										+ vs
										+ " and "
										+ vs1
										+ " do not have the same enumeration type.\n";
							}
						} else {
							if(t1 == 1 && op != 0 && op != 1) {
								return Util.getErrorHeader(opStartline,
										opStartcolumn, opLength)
										+ "only equality or inequality test is allowed in "
										+ toString() + ".\n";
							}					
							((variable) operands[0]).set_var_type(p);
							((variable) operands[1]).set_var_type(p1);
							return errorMessage;
						}
					} else {
						return errorMessage + Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " and "
								+ vs1
								+ " have different type.\n";
					}
				} else if (left_var && !right_var) {// lhs is a variable and rhs
													// is an enumeration value
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}					
					int t1 = p.get_type(); // lhs' type
					if (t1 == 3) {// lhs must be enumeration
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							// change the rhs to be an enumeration value
							operands[1] = new enum_value(new String(vs1),
									operands[1].startline,
									operands[1].startcolumn);
							return errorMessage;
						} else {
							return errorMessage + Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return errorMessage + Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs + " must have an enumeration type.\n";
					}
				} else if (!left_var && right_var) {// lhs is an enumeration value
													// and rhs is a variable
					if(op != 0 && op != 1) {
						return Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}					
					int t2 = p1.get_type(); // rhs' type
					if (t2 == 3) {// rhs must be enumeration
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in rhs to its type
							((variable) operands[1]).set_var_type(p1);
							// change the lhs to be an enumeration value
							operands[0] = new enum_value(new String(vs),
									operands[0].startline,
									operands[0].startcolumn);
							return errorMessage;
						} else {
							return errorMessage + Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1
									+ " does not have the value "
									+ vs
									+ "\n";
						}
					} else {
						return errorMessage + Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1 + " must have an enumeration type.\n";
					}
				} else {
					return errorMessage + Util.getErrorHeader(v1.startline, v1.startcolumn, vs
							.length())
							+ vs + " or " + vs1 + " must be a variable.\n";
				}
			} else if (left_var) {
				if(!left_defined)
					return errorMessage;
				left = p.get_type();
				if (right == 1) {// right hand side is a boolean value
					if (left != 1) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[0]).set_var_type(p);
						return errorMessage;
					} else {
						return errorMessage + Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (right == 2) {// right hand side is an integer
					if (left != 2) {
						return Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ " in "
								+ toString()
								+ " is not a bounded integer variable.\n";
					}
					((variable) operands[0]).set_var_type(p);
					return errorMessage;
				} else if (right == 3) {// right hand side is an enumeration
										// value. It cannot happen. But we still
										// check it.
					//System.out.println("        enumeration value cannot appear here.\n");
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs1 = ((enum_value) operands[1]).get_value();
						TreeSet<String> s1 = ((enumerate) (p)).get_enumvalue();
						if (s1.contains(vs1)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return errorMessage;
						} else {
							return errorMessage + Util.getErrorHeader(v1.startline,
									v1.startcolumn, vs.length())
									+ vs
									+ " does not have the value "
									+ vs1
									+ "\n";
						}
					} else {
						return errorMessage + Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// right hand side is an arithmetic expression
					if (p.get_type() == 2) {
						String str = ((arithmetic_expression) operands[1])
								.check_var_and_value1(vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[0]).set_var_type(p);
							return errorMessage;
						} else
							return errorMessage + str
									+ Util.getErrorHeader(v1.startline,
											v1.startcolumn, vs.length())
									+ vs
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[1])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return errorMessage + Util.getErrorHeader(v1.startline,
								v1.startcolumn, vs.length())
								+ vs
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[1])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return errorMessage + Util.getErrorHeader(v1.startline, v1.startcolumn, vs
						.length())
						+ vs + " must be a variable.\n";
			}
		} else if (right == 0) {// right hand side is a variable
			variable v2 = ((variable) operands[1]);
			String vs1 = ((variable) operands[1]).get_variable_name();
			basictype p1 = null;
			if (v2.is_agent_name_null())
				right_var = false;
			else {
				String ag_name = v2.get_agent_name();
				Hashtable<String, basictype> gp = vars.get(ag_name);
				if (gp == null) {
					return errorMessage + Util.getErrorHeader(v2.agstartline,
							v2.agstartcolumn, ag_name.length())
							+ "undefined agent " + ag_name +"\n";
				}
				p1 = gp.get(vs1);
				if (p1 == null) {// the variable is not defined
					return errorMessage + Util.getErrorHeader(v2.startline, v2.startcolumn,
							vs1.length())
							+ "variable "
							+ vs1
							+ " is not defined in agent "
							+ ag_name + "\n";
				}
			}
			if (right_var) {
				right = p1.get_type();
				if (left == 1) {// left hand side is a boolean value
					if (right != 1) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					if (op == 0 || op == 1) {// only equality is allowed here
						// add a link in variable to its type
						((variable) operands[1]).set_var_type(p1);
						return errorMessage;
					} else {
						return errorMessage + Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else if (left == 2) {// left hand side is an integer
					if (right != 2) {
						return Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ " in "
								+ toString()
								+ " is not a Boolean variable.\n";
					}
					((variable) operands[1]).set_var_type(p1);
					return errorMessage;
				} else if (left == 3) {// left hand side is an enumeration value.
										// It cannot happen. But we still check
										// it.
					//System.out.println("        enumeration value cannot appear here.\n");
					if (op == 0 || op == 1) {// only equality is allowed here
						String vs = ((enum_value) operands[0]).get_value();
						TreeSet<String> s2 = ((enumerate) (p1)).get_enumvalue();
						if (s2.contains(vs)) {// find a matched value in the
												// enumeration type
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return errorMessage;
						} else {
							return errorMessage + Util.getErrorHeader(v2.startline,
									v2.startcolumn, vs1.length())
									+ vs1 + " does not have the value " + vs + "\n";
						}
					} else {
						return errorMessage + Util.getErrorHeader(opStartline,
								opStartcolumn, opLength)
								+ "only equality or inequality test is allowed in "
								+ toString() + ".\n";
					}
				} else {// left hand side is an arithmetic expression
					if (p1.get_type() == 2) {
						String str = ((arithmetic_expression) operands[0])
								.check_var_and_value1(vars, document);
						if (str == "") {
							// add a link in lhs to its type
							((variable) operands[1]).set_var_type(p1);
							return errorMessage;
						} else
							return errorMessage + str
									+ Util.getErrorHeader(v2.startline,
											v2.startcolumn, vs1.length())
									+ vs1
									+ "does not have integer type or "
									+ ((arithmetic_expression) operands[1])
											.toString()
									+ " is not a correct arithmetic expression.\n";
					} else {
						return errorMessage + Util.getErrorHeader(v2.startline,
								v2.startcolumn, vs1.length())
								+ vs1
								+ "does not have integer type or "
								+ ((arithmetic_expression) operands[0])
										.toString()
								+ " is not a correct arithmetic expression.\n";
					}
				}
			} else {
				return errorMessage + Util.getErrorHeader(v2.startline, v2.startcolumn, vs1
						.length())
						+ vs1 + " must be a variable.\n";
			}
		} else if (left >= 5 && left <= 8) { // left hand side is an arithmetic expression
			if (right == 2) // rhs is an integer
				return errorMessage + ((arithmetic_expression) operands[0])
						.check_var_and_value1(vars, document);
			else if (right >= 5 && right <= 8) // rhs is an arithmetic expression
				return errorMessage + ((arithmetic_expression) operands[0])
						.check_var_and_value1(vars, document)
						+ ((arithmetic_expression) operands[1])
								.check_var_and_value1(vars, document);
			else {
				return errorMessage + Util.getErrorHeader(operands[1].startline,
						operands[1].startcolumn, Util.getLength(document,
								operands[1].startline, operands[1].startcolumn,
								operands[1].endline, operands[1].endcolumn))
						+ "right hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		} else if (right >= 5 && right <= 8) { //right  hand side is an arithmetic expression
			if (left == 2) // lhs is an integer
				return errorMessage + ((arithmetic_expression) operands[1])
						.check_var_and_value1(vars, document);
			else {
				return errorMessage + Util.getErrorHeader(operands[0].startline,
						operands[0].startcolumn, Util.getLength(document,
								operands[0].startline, operands[0].startcolumn,
								operands[0].endline, operands[0].endcolumn))
						+ "left hand side in "
						+ toString()
						+ " has a wrong type.\n";
			}
		}

		return errorMessage + Util.getErrorHeader(operands[0].startline,
				operands[0].startcolumn, Util.getLength(document,
						operands[0].startline, operands[0].startcolumn,
						operands[1].endline, operands[1].endcolumn))
				+ "illegal logic expression: " + toString() + "\n";
	}

	/**
	 * Evaluate the expression in the given global state
	 * @param gstate
	 * @return true if the expression is satisfied, false otherwise
	 */
	public boolean evaluate(String agentName, GlobalState gstate) {
		int ltype = operands[0].get_type();
		int rtype = operands[1].get_type();
		
		if(ltype == 0) {// left hand operand is a variable
			variable lvar = (variable)operands[0];
			String agentName1 = lvar.get_agent_name();
			if(agentName1 == null || Util.isEmpty(agentName1))
				agentName1 = agentName;
			expression lvalue = gstate.getValue(agentName1, lvar.get_variable_name());
			if(rtype == 0) { // right hand operand is a variable
				variable rvar = (variable)operands[1];
				String agentName2 = rvar.get_agent_name();
				if(agentName2 == null || Util.isEmpty(agentName2))
					agentName2 = agentName;
				expression rvalue = gstate.getValue(agentName2, rvar.get_variable_name());
				int type = lvalue.get_type();
				if(type == 1) {// boolean value
					return compareTwoBooleanValues(((bool_value)lvalue).get_value(), ((bool_value)rvalue).get_value());
				} else if(type == 2) {//bounded integer
					return compareTwoIntegers(((int_value)lvalue).get_value(), 
							((int_value)rvalue).get_value());
				} else {//enumeration value
					return compareTwoEnumerationValues(((enum_value)lvalue).get_value(), ((enum_value)rvalue).get_value());
				}
			} else if(rtype == 1) { // right hand operand is a boolean value
				return compareTwoBooleanValues(((bool_value)lvalue).get_value(), ((bool_value)operands[1]).get_value());
			} else if(rtype == 2) { // right hand operand is an integer value
				return compareTwoIntegers(((int_value)lvalue).get_value(), 
						((int_value)operands[1]).get_value());
			} else if(rtype == 3) {// right hand operand is an enumeration value
				return compareTwoEnumerationValues(((enum_value)lvalue).get_value(), ((enum_value)operands[1]).get_value());
			} else { // right hand operand is an arithmetic expression
				return compareTwoIntegers(((int_value)lvalue).get_value(), 
						((arithmetic_expression)operands[1]).evaluate(agentName, gstate));
			}
		} else if(rtype == 0) {// right hand operand is a variable
			variable rvar = (variable)operands[1];
			String agentName2 = rvar.get_agent_name();
			if(agentName2 == null || Util.isEmpty(agentName2))
				agentName2 = agentName;
			expression rvalue = gstate.getValue(agentName2, rvar.get_variable_name());
			if(ltype == 1) { // left hand operand is a boolean value
				return compareTwoBooleanValues(((bool_value)operands[0]).get_value(), ((bool_value)rvalue).get_value());
			} else if(ltype == 2) { // left hand operand is an integer value
				return compareTwoIntegers(((int_value)operands[0]).get_value(), 
						((int_value)rvalue).get_value());
			} else if(ltype == 3) {// left hand operand is an enumeration value
				return compareTwoEnumerationValues(((enum_value)operands[0]).get_value(), ((enum_value)rvalue).get_value());
			} else { // left hand operand is an arithmetic expression
				return compareTwoIntegers(((arithmetic_expression)operands[0]).evaluate(agentName, gstate), 
					((int_value)rvalue).get_value());
			}
		} else if(ltype == 1) { // both operands are a boolean value
			return compareTwoBooleanValues(((bool_value)operands[0]).get_value(), ((bool_value)operands[1]).get_value());
		} else if(ltype == 2) { // both operands are an integer value
			return compareTwoIntegers(((int_value)operands[0]).get_value(), 
					((int_value)operands[1]).get_value());
		} else if(ltype == 3) {// both operands are an enumeration value
			return compareTwoEnumerationValues(((enum_value)operands[0]).get_value(), ((enum_value)operands[1]).get_value());
		} else { // both operands are an arithmetic expression
			return compareTwoIntegers(((arithmetic_expression)operands[0]).evaluate(agentName, gstate), 
					((arithmetic_expression)operands[1]).evaluate(agentName, gstate));
		}
	}
	
	private boolean compareTwoIntegers(int lint, int rint) {
		if(op == 0)
			return lint == rint;
		else if(op == 1)
			return lint != rint;
		else if(op == 2)
			return lint < rint;
		else if(op == 3)
			return lint <= rint;
		else if(op == 4)
			return lint > rint;
		else 
			return lint >= rint;
	}
	
	private boolean compareTwoBooleanValues(boolean lbool, boolean rbool) {
		if(lbool == rbool)
			return (op==0 ? true : false);
		else
			return (op==1 ? true : false);
	}

	private boolean compareTwoEnumerationValues(String lenum, String renum) {
		if(lenum.compareTo(renum) == 0)
			return (op==0 ? true : false);
		else
			return (op==1 ? true : false);
	}
	
	public boolean evaluate(String agentName, GlobalState gstate, Hashtable<String, String> actions) {
		if(operands[0].get_type() == 4) { // action expression
			String agentName1 = ((laction)operands[0]).get_agent_name();
			if(agentName1 == null || Util.isEmpty(agentName1))
				agentName1 = agentName;
			String ract = ((variable)operands[1]).get_variable_name();
			String lact = actions.get(agentName1);
			if(lact == null || lact.compareTo(ract) != 0)
				return false;
			else
				return true;
		} else 
			return evaluate(agentName, gstate);
	}
	
	public boolean evaluate1(String agentName, GlobalState gstate, Hashtable<String, TreeSet<String>> actions) {
		if(operands[0].get_type() == 4) { // action expression
			String agentName1 = ((laction)operands[0]).get_agent_name();
			if(agentName1 == null || Util.isEmpty(agentName1))
				agentName1 = agentName;
			String ract = ((variable)operands[1]).get_variable_name();
			TreeSet<String> lacts = actions.get(agentName1);
			if(lacts == null || !lacts.contains(ract))
				return false;
			else
				return true;
		} else 
			return evaluate(agentName, gstate);
	}

	public boolean evaluate2(GlobalState gstate) {
		return evaluate("", gstate);
	}
	

	/**
	 * Generate the list of logic expressions (indeed assignments) as the negation of the current logic expression/assignment
	 * @param expr
	 * @return the set of logic expressions
	 */
	public ArrayList<logic_expression> getNegation() {
		ArrayList<logic_expression> lexprs = new ArrayList<logic_expression>();
		
		variable var = (variable)operands[0];
		expression value = operands[1];
		int value_type = value.get_type();
		if(value_type == 1) {
			bool_value b = new bool_value(!((bool_value)value).get_value(), 0, 0);
			lexprs.add(new logic_expression(0, var, b));
		} else if(value_type == 3) {
			basictype bt = var.get_var_type();
			TreeSet<String> values = ((enumerate)bt).get_enumvalue();
			String enumvalue = ((enum_value)value).get_value();
			for(Iterator<String> i = values.iterator(); i.hasNext();) {
				String element = i.next();
				if(element.compareTo(enumvalue) != 0) {
					enum_value b = new enum_value(element, 0, 0);
					lexprs.add(new logic_expression(0, var, b));
				}
			}
		} else if(value_type == 2) {
			basictype bt = var.get_var_type();
			int lowerbound = ((rangedint)bt).get_lowerbound();
			int upperbound = ((rangedint)bt).get_upperbound();
			int intvalue = ((int_value)value).get_value();
			for(int i = lowerbound; i<=upperbound; i++) {
				if(i != intvalue) {
					int_value b = new int_value(i, 0, 0, 0, 0);
					lexprs.add(new logic_expression(0, var, b));
				}
			}
		} else {
			System.out.println("The value type " + value_type + "should not happen!");
		}
	
		return lexprs;
	}
	
	public boolean isSameAction(logic_expression l1) {
		if(op == 0 && l1.op == 0) {
			String ag_name1 = ((laction) operands[0]).get_agent_name();
			String ag_name2 = ((laction) l1.operands[0]).get_agent_name();
			if(ag_name1.compareTo(ag_name2) == 0) {
				String act_name1 = ((variable) operands[1]).get_variable_name();
				String act_name2 = ((variable) l1.operands[1]).get_variable_name();
				if(act_name1.compareTo(act_name2) ==0)
					return true;
			}
		}
		
		return false;
	}
}
