package org.mcmas.ui.syntax;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.TreeSet;

public class modal_formula {
	/* 0: term, 1=AND, 2=OR, 3=NOT, 4=IMPLIES,
    10=AG, 11=EG, 12=AX, 13=EX, 14=AF, 15=EF, 16=AU, 17=EU,
    30=K, 31=GK (everybody knows), 32=GCK (commond knowledge),
    40=O (deontic), 41=KH (K-hat), 42=DK (distributed knowledge),
    43=DKH (distrib. K assuming correct behaviour),
    45=<group>X (atl quantifier for X),
    46=<group>F (atl quantifier for F),
    47=<group>G (atl quantifier for G),
    48=<group> U (atl quantifier for U)
 */
 int op; 
 Object[] obj;
 
 public modal_formula(atomic_proposition obj1) { // term
	  op = 0;
	  obj = new Object[1];
	  obj[0] = obj1;
	}

 public modal_formula(int o, modal_formula f1) { // sigle operand formula
	  op = o;
	  obj = new Object[1];
	  obj[0] = f1;
	}

 public modal_formula(int o, modal_formula f1, modal_formula f2) { // two operands formula
	  op = o;
	  obj = new Object[2];
	  obj[0] = f1;
	  obj[1] = f2;
	}

 public modal_formula(int o, modal_formula f1, modal_formula f2, modal_formula f3) { // three operands formula
	  op = o;
	  obj = new Object[3];
	  obj[0] = f1;
	  obj[1] = f2;
	  obj[2] = f3;
	}

 public int get_op() {
	  return op;
	}

 public Object get_operand(int i) {
	  if(i==0 && obj[0]!=null)
	    return (obj[0]);
	  else if(i==1 && obj[1]!=null && 
		  (op==1 || op==2 || op==4 || op==16 || op==17 ||
		   op==30 || op==31 || op==32 || op==40 ||
		   op==41 || op==42 || op==43 || op==45 ||
		   op==46 || op==47 || op==48)) {
		  return (obj[1]);
	  } else if(i==2 && obj[2]!=null && (op==41 || op==43 || op==48))
	    return (obj[2]);
	  else {
	    System.out.println( " error: operand " + i + " not found!");
	    return null;
	  }
	}
 
 private int level() {
	 switch(op) {
	  case 1: // AND
	  case 2: // OR
	  case 4: // IMPLIES
	    return 1;
	  case 3: // NOT
		return 2;
	  case 10: // AG
	  case 11: // EG
	  case 12: // AX
	  case 13: // EX
	  case 14: // AF
	  case 15: // EF
	    return 3;
	    
	  case 16: // AU
	  case 17: // EU
	  case 30: // K
	  case 40: // O -- Does it allow a group name to appear? 
	  case 31: // GK
	  case 32: // GCK
	  case 42: // DK
	  case 45: // ATL X
	  case 46: // ATL F
	  case 47: // ATL G
	  case 41: // KH
	  case 43: // DKH
	  case 48: // ATL U
	  case 0: // A leaf node
		  return 4;
	  }
	 return 0;
 }
 
 public String toString() {
	 String s1, s2;
	  switch(op) {
	  case 0: 
	    return ((atomic_proposition )obj[0]).toString();
	  case 1:
		  s1 = ((modal_formula )obj[0]).toString();
		  s1 = ((modal_formula )obj[0]).level() > this.level() ? s1 : "(" + s1 + ")";
		  s2 = ((modal_formula )obj[1]).toString();
		  s2 = ((modal_formula )obj[1]).level() > this.level() ? s2 : "(" + s2 + ")";
	    return s1 + " && " + s2;
	  case 2:
		  s1 = ((modal_formula )obj[0]).toString();
		  s1 = ((modal_formula )obj[0]).level() > this.level() ? s1 : "(" + s1 + ")";
		  s2 = ((modal_formula )obj[1]).toString();
		  s2 = ((modal_formula )obj[1]).level() > this.level() ? s2 : "(" + s2 + ")";
	    return s1 + " || " + s2;
	  case 3:
		  if(((modal_formula )obj[0]).level() > this.level())
			  return "! " + ((modal_formula )obj[0]).toString();
		  else if (((modal_formula )obj[0]).level() == this.level())
			  return ((modal_formula )obj[0]).toString();
		  else
			  return "! (" + ((modal_formula )obj[0]).toString() + ")";
	  case 4:
		  s1 = ((modal_formula )obj[0]).toString();
		  s1 = ((modal_formula )obj[0]).level() > this.level() ? s1 : "(" + s1 + ")";
		  s2 = ((modal_formula )obj[1]).toString();
		  s2 = ((modal_formula )obj[1]).level() > this.level() ? s2 : "(" + s2 + ")";
	    return s1 + " -> " + s2;
	  case 10:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "AG " + ((modal_formula )obj[0]).toString();
		  else
			  return "AG(" + ((modal_formula )obj[0]).toString()+")";
	  case 11:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "EG " + ((modal_formula )obj[0]).toString();
		  else
			  return "EG(" + ((modal_formula )obj[0]).toString()+")";
	  case 12:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "AX " + ((modal_formula )obj[0]).toString();
		  else
			  return "AX(" + ((modal_formula )obj[0]).toString()+")";
	  case 13:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "EX " + ((modal_formula )obj[0]).toString();
		  else
			  return "EX(" + ((modal_formula )obj[0]).toString()+")";
	  case 14:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "AF " + ((modal_formula )obj[0]).toString();
		  else
			  return "AF(" + ((modal_formula )obj[0]).toString()+")";
	  case 15:
		  if(((modal_formula )obj[0]).level() >= this.level())
			  return "EF " + ((modal_formula )obj[0]).toString();
		  else
			  return "EF (" + ((modal_formula )obj[0]).toString()+")";
	  case 16:
		  s1 = ((modal_formula )obj[0]).toString();
		  s1 = ((modal_formula )obj[0]).level() > 1 ? s1 : "(" + s1 + ")";
		  s2 = ((modal_formula )obj[1]).toString();
		  s2 = ((modal_formula )obj[1]).level() > 1 ? s2 : "(" + s2 + ")";
	    return "A("+ s1 + " U " + s2 +")";
	  case 17:
		  s1 = ((modal_formula )obj[0]).toString();
		  s1 = ((modal_formula )obj[0]).level() > 1 ? s1 : "(" + s1 + ")";
		  s2 = ((modal_formula )obj[1]).toString();
		  s2 = ((modal_formula )obj[1]).level() > 1 ? s2 : "(" + s2 + ")";
	    return "E("+ s1 + " U " + s2 +")";
	  case 30:
	    return "K("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+")";
	  case 31:
	    return "GK("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+")";
	  case 32:
	    return "GCK("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+")";
	  case 40:
	    return "O("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+")";
	  case 41:
	    return "KH("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+ 
	      ", " + ((modal_formula )obj[2]).toString()+")";
	  case 42:
	    return "DK("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+")";
	  case 43:
	    return "DKH("+((modal_formula )obj[0]).toString() + ", " + ((modal_formula )obj[1]).toString()+ 
	      ", " + ((modal_formula )obj[2]).toString()+")";
	  case 45:
	    return "(<"+((modal_formula )obj[0]).toString() + ">X " + ((modal_formula )obj[1]).toString()+")";
	  case 46:
	    return "(<"+((modal_formula )obj[0]).toString() + ">F " + ((modal_formula )obj[1]).toString()+")";
	  case 47:
	    return "(<"+((modal_formula )obj[0]).toString() + ">G " + ((modal_formula )obj[1]).toString()+")";
	  case 48:
	    return "<"+((modal_formula )obj[0]).toString() + ">(" + ((modal_formula )obj[1]).toString()+ 
	      " U " + ((modal_formula )obj[2]).toString()+")";
	  }
	  return "";
	}

 public String check_atomic_proposition(int type, Hashtable<String, basic_agent > is_agents,
  Hashtable<String, bool_expression > is_evaluation, Hashtable<String, TreeSet<groupitem> > is_groups) { 
	  // type=0: atomic proposition, type=1: agent, type=2: group, type=3: agent or group
	  String b1, b2, b3;
	  switch(op) {
	  case 1: // AND
	  case 2: // OR
	  case 4: // IMPLIES
	  case 16: // AU
	  case 17: // EU
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2);
	  case 3: // NOT
	  case 10: // AG
	  case 11: // EG
	  case 12: // AX
	  case 13: // EX
	  case 14: // AF
	  case 15: // EF
	    return ((modal_formula )obj[0]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	  case 30: // K
	  case 40: // O -- Does it allow a group name to appear? 
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(1, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2);
	  case 31: // GK
	  case 32: // GCK
	  case 42: // DK
	  case 45: // ATL X
	  case 46: // ATL F
	  case 47: // ATL G
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(2, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2);
	  case 41: // KH
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(1, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(3, is_agents, is_evaluation, is_groups);
	    b3 = ((modal_formula )obj[2]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2 + b3);
	  case 43: // DKH
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(2, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(3, is_agents, is_evaluation, is_groups);
	    b3 = ((modal_formula )obj[2]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2 + b3);
	  case 48: // ATL U
	    b1 = ((modal_formula )obj[0]).check_atomic_proposition(2, is_agents, is_evaluation, is_groups);
	    b2 = ((modal_formula )obj[1]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    b3 = ((modal_formula )obj[2]).check_atomic_proposition(0, is_agents, is_evaluation, is_groups);
	    return (b1 + b2 + b3);
	  case 0: // A leaf node
			atomic_proposition ap = (atomic_proposition) obj[0];
			String name = ap.get_proposition();
			switch (type) {
			case 0:
				if (!is_evaluation.containsKey(name)) {
					return Util.getErrorHeader(ap.line, ap.column, name.length())
							+ "atomic proposition " + name + " is not defined.\n";
				} else
					return "";
			case 1:
				if (!is_agents.containsKey(name)) {
					return Util.getErrorHeader(ap.line, ap.column, name.length())
							+ "agent " + name + " is not defined.\n";
				} else
					return "";
			case 2:
				if (!is_groups.containsKey(name)) {
					return Util.getErrorHeader(ap.line, ap.column, name.length())
							+ "group " + name + " is not defined.\n";
				} else
					return "";
			case 3:
				if (!is_agents.containsKey(name) && !is_groups.containsKey(name)) {
					return Util.getErrorHeader(ap.line, ap.column, name.length())
							+ "agent " + name + " is not defined.\n";
				} else
					return "";
	    }
	  }
	  return Util.getErrorHeader(0, 0, 1) + "undefined error in formulae. report it to the developers.\n";
	}
 public void look_flags(boolean epistemic, boolean deontic, boolean common_knowledge, 
				       boolean deontic_knowledge, boolean distributed_knowledge, 
				       Hashtable<String, TreeSet<String> > is_groups) {
	  String name;
	  Object id;
	  switch(op) {
	  case 1: // AND
	  case 2: // OR
	  case 4: // IMPLIES
	  case 16: // AU
	  case 17: // EU
	    ((modal_formula )obj[0]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 3: // NOT
	  case 10: // AG
	  case 11: // EG
	  case 12: // AX
	  case 13: // EX
	  case 14: // AF
	  case 15: // EF
	    ((modal_formula )obj[0]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 30: // K
	    epistemic = true;
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 40: // O -- Does it allow a group name to appear? 
	    deontic = true;
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 31: // GK
	    epistemic = true;
	    common_knowledge = true;
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 32: // GCK
	    epistemic = true;
	    common_knowledge = true;
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 42: // DK
	    epistemic = true;
	    distributed_knowledge = true;
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 45: // ATL X
	  case 46: // ATL F
	  case 47: // ATL G
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 41: // KH
	    deontic = true;
	    epistemic = true;
	    id = ((modal_formula )obj[1]).get_operand(1);
	    name = ((atomic_proposition )id).get_proposition();
	    if(is_groups.containsKey(name)) // the second parameter is a group
	      deontic_knowledge = true;
	    ((modal_formula )obj[2]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 43: // DKH
	    deontic = true;
	    epistemic = true;
	    distributed_knowledge = true;
	    id = ((modal_formula )obj[1]).get_operand(1);
	    name = ((atomic_proposition )id).get_proposition();
	    if(is_groups.containsKey(name)) // the second parameter is a group
	      deontic_knowledge = true;
	    ((modal_formula )obj[2]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);    
	    return;
	  case 48: // ATL U
	    ((modal_formula )obj[1]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    ((modal_formula )obj[2]).look_flags(epistemic, deontic, common_knowledge, 
						  deontic_knowledge, distributed_knowledge, is_groups);
	    return;
	  case 0: // A leaf node
	    return;
	  }
	}

 public boolean is_ACTLK() {
		/* Return TRUE if the formula is ACTL (i.e., only A quantifiers and
		  K and negation only in front of propositions.
		  All the negations should have been pushed down already.
		 */

		switch(op) {
			  case 0: // leaf
			   {
				   return true;
			   }
			   case 1: // AND
			   {
				   return ( ((modal_formula)obj[0]).is_ACTLK() & ((modal_formula)obj[1]).is_ACTLK() );
			   }
			   case 2: // OR
			   {
				   return ( ((modal_formula)obj[0]).is_ACTLK() & ((modal_formula)obj[1]).is_ACTLK() );
			   }
			   case 3: // NOT
			   {
			     if (((modal_formula)obj[0]).get_op() == 0 ) {
			    	 return true;
			     } else {
			    	 // however, this case should not be here
			    	 return false;
			     }
			   }
			   case 4: // IMPLIES
			   {
				   // Again, this should not be here.
				     if (((modal_formula)obj[0]).get_op() == 0 ) {
				    	 return ((modal_formula)obj[1]).is_ACTLK();
				     } else {
				    	 return false;
				     }
			   }
			  
			  case 10: // AG
			  {
				  return ((modal_formula)obj[0]).is_ACTLK();
			  }
			  case 11: // EG 
			  {
				  return false;
			  }
			  case 12: // AX
			  {
				  return ((modal_formula)obj[0]).is_ACTLK();
			  }
			  case 13: // EX
			  {
				  return false;
			  }
			  case 14: // AF
			  {
				  return ((modal_formula)obj[0]).is_ACTLK();
			  }
			  case 15: // EF
			  {
				  return false;
			  }
			  case 16: // AU
			  {
				   return ( ((modal_formula)obj[0]).is_ACTLK() & ((modal_formula)obj[1]).is_ACTLK() );
			  }
			  case 17: // EU
			  {
				  return false;
			  }
			  
			  case 30: // K
			  {
				  return ((modal_formula)obj[1]).is_ACTLK();
			  }
			  case 42:
			  case 43: 
			  {	// KH and DKH
				  return ((modal_formula)obj[2]).is_ACTLK();
			  }		  
			  default:
			  {
				  return ((modal_formula)obj[1]).is_ACTLK();
			  }		  
		}  
		
		
	}




 public boolean is_ECTLK() {
		/* Return TRUE if the formula is ECTL (i.e., only E quantifiers and
		  \neg K, i.e., negation only in front of propositions and K operator
		 */
		
		switch(op) {
				  case 0: // leaf
				   {
					   return true;
				   }
				   case 1: // AND
				   {
					   return ( ((modal_formula)obj[0]).is_ECTLK() & ((modal_formula)obj[1]).is_ECTLK() );
				   }
				   case 2: // OR
				   {
					   return ( ((modal_formula)obj[0]).is_ECTLK() & ((modal_formula)obj[1]).is_ECTLK() );
				   }
				   case 3: // NOT
				   {
				     if ( ((modal_formula)obj[0]).get_op() == 0 ) {
				    	 return true;
				     } else if ( ((modal_formula)obj[0]).get_op() == 30 ) {
				    	 return ((modal_formula)(((modal_formula)obj[0]).get_operand(1))).is_ECTLK();
				     } else {
				    	 return false;
				     }
				   }
				   case 4: // IMPLIES
				   {
					     if (((modal_formula)obj[0]).get_op() == 0 ) {
					    	 return ((modal_formula)obj[1]).is_ECTLK();
					     } else {
					    	 return false;
					     }
				   }
				  
				  case 10: // AG
				  {
					  return false;
				  }
				  case 11: // EG 
				  {
					  return ((modal_formula)obj[0]).is_ECTLK();
				  }
				  case 12: // AX
				  {
					  return false;
				  }
				  case 13: // EX
				  {
					  return ((modal_formula)obj[0]).is_ECTLK();
				  }
				  case 14: // AF
				  {
					  return false;
				  }
				  case 15: // EF
				  {
					  return ((modal_formula)obj[0]).is_ECTLK();
				  }
				  case 16: // AU
				  {
					  return false;
				  }
				  case 17: // EU
				  {
					  return ( ((modal_formula)obj[0]).is_ECTLK() & ((modal_formula)obj[1]).is_ECTLK() );
				  }
				  
				  case 30: // K
				  {
					  return false;
				  }
				  case 42:
				  case 43: 
				  {	// KH and DKH
					  return ((modal_formula)obj[2]).is_ECTLK();
				  }		  
				  default:
				  {
					  return ((modal_formula)obj[0]).is_ECTLK();
				  }	 
			} 
	}

 	public void getAgents(ArrayList<String> agnames, Hashtable<String, basic_agent> is_agents,
 			Hashtable<String, TreeSet<groupitem>> is_groups) {
 		  switch(op) {
 		  case 1: // AND
 		  case 2: // OR
 		  case 4: // IMPLIES
 		  case 16: // AU
 		  case 17: // EU
 		    ((modal_formula )obj[0]).getAgents(agnames, is_agents, is_groups);
 		    ((modal_formula )obj[1]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 3: // NOT
 		  case 10: // AG
 		  case 11: // EG
 		  case 12: // AX
 		  case 13: // EX
 		  case 14: // AF
 		  case 15: // EF
 		    ((modal_formula )obj[0]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 30: // K
 		  case 40: // O -- Does it allow a group name to appear? 
 			String name = ((atomic_proposition) ((modal_formula )obj[0]).get_operand(0)).get_proposition();
 			agnames.add(name);
 		    ((modal_formula )obj[1]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 31: // GK
 		  case 32: // GCK
 		  case 42: // DK
 		  case 45: // ATL X
 		  case 46: // ATL F
 		  case 47: // ATL G
 		    TreeSet<groupitem> group = is_groups.get(((atomic_proposition) ((modal_formula )obj[0]).get_operand(0)).get_proposition());
 		    for(Iterator<groupitem> i=group.iterator(); i.hasNext(); ){
 		    	groupitem agent = i.next();
 		    	agnames.add(agent.name);
 		    }
 		    ((modal_formula )obj[1]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 41: // KH
 			String name1 = ((atomic_proposition) ((modal_formula )obj[0]).get_operand(0)).get_proposition();
 			agnames.add(name1);
 			String agent1 = ((atomic_proposition) ((modal_formula )obj[1]).get_operand(0)).get_proposition();
 			if(is_agents.containsKey(agent1))
 				agnames.add(agent1);
 			else {
 				group = is_groups.get(agent1);
 	 		    for(Iterator<groupitem> i=group.iterator(); i.hasNext(); ){
 	 		    	groupitem agent = i.next();
 	 		    	agnames.add(agent.name);
 	 		    }
 			}
 		    ((modal_formula )obj[2]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 43: // DKH
 			TreeSet<groupitem> group1 = is_groups.get(((atomic_proposition) ((modal_formula )obj[0]).get_operand(0)).get_proposition());
  		    for(Iterator<groupitem> i=group1.iterator(); i.hasNext(); ){
  		    	groupitem agent = i.next();
  		    	agnames.add(agent.name);
  		    }
  		    agent1 = ((atomic_proposition) ((modal_formula )obj[1]).get_operand(0)).get_proposition();
			if(is_agents.containsKey(agent1))
				agnames.add(agent1);
			else {
				group = is_groups.get(agent1);
	 		    for(Iterator<groupitem> i=group.iterator(); i.hasNext(); ){
	 		    	groupitem agent = i.next();
	 		    	agnames.add(agent.name);
	 		    }
			}
 		    ((modal_formula )obj[2]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 48: // ATL U
 			TreeSet<groupitem> group2 = is_groups.get(((atomic_proposition) ((modal_formula )obj[0]).get_operand(0)).get_proposition());
  		    for(Iterator<groupitem> i=group2.iterator(); i.hasNext(); ){
  		    	groupitem agent = i.next();
  		    	agnames.add(agent.name);
  		    }
 		    ((modal_formula )obj[1]).getAgents(agnames, is_agents, is_groups);
 		    ((modal_formula )obj[2]).getAgents(agnames, is_agents, is_groups);
 		    break;
 		  case 0: // A leaf node
 				break;
 		  }

 	}
}
